SystemOrganization addCategory: #'Sight-Cst-Analyzing'!
SystemOrganization addCategory: #'Sight-Cst-Coverage'!
SystemOrganization addCategory: #'Sight-Cst-Coverage-Tests'!
SystemOrganization addCategory: #'Sight-Cst-Callgraph'!
SystemOrganization addCategory: #'Sight-Cst-Callgraph-Tests'!
SystemOrganization addCategory: #'Sight-Cst-Callgraph-Testbed'!
SystemOrganization addCategory: #'Sight-Cst-Distribution'!
SystemOrganization addCategory: #'Sight-Cst-Distribution-Tests'!
SystemOrganization addCategory: #'Sight-Cst-Install'!
SystemOrganization addCategory: #'Sight-Cst'!
SystemOrganization addCategory: #'Sight-Cst-Tests'!
SystemOrganization addCategory: #'Sight-Cst-Ui'!
SystemOrganization addCategory: #'Sight-Cst-Ui-Text'!
SystemOrganization addCategory: #'Sight-Cst-Debugger'!

Exception subclass: #SdNonDeterministicBehaviorDetected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdNonDeterministicBehaviorDetected methodsFor: 'priv handling' stamp: 'mt 7/15/2011 13:01:55.166'!
defaultAction

	UnhandledError signalForException: self.! !

!TestResult methodsFor: '*Sight-Cst' stamp: 'bs 1/15/2010 21:48'!
defectTestMethods
	^ (self defects collect: [ :aTestCase | aTestCase class >> aTestCase selector ]) asIdentitySet! !

!TestResult methodsFor: '*Sight-Cst' stamp: 'bs 12/22/2009 18:34'!
isDefect: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	
	^ self defects 
		anySatisfy: [ :testCase | 
			(testCase selector == selector) and: [testCase class == class] ]! !

!TestResult methodsFor: '*Sight-Cst' stamp: 'bs 2/20/2010 21:23:04.994'!
postCopy
	failures := failures collect: [ :ea | ea class selector: ea selector ].
	errors := errors collect: [ :ea | ea class selector: ea selector ].
	passed := passed collect: [ :ea | ea class selector: ea selector ].! !

!TestResult methodsFor: '*Sight-Cst' stamp: 'bs 12/22/2009 15:25'!
removeIfPresent: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	{errors. failures. passed} do: [ :aTestSet | 
		aTestSet 
			select: [ :testCase | (testCase selector == selector) and: [testCase class == class] ]
			thenDo: [ :testCase | aTestSet remove: testCase. ] ].! !

!TestResult methodsFor: '*Sight-Cst-override' stamp: 'bs 12/21/2009 12:36'!
runCase: aTestCase
	| testCasePassed |
	testCasePassed := true.
	[[aTestCase runCase] 
			on: self class failure
			do: 
				[:signal | 
				failures add: aTestCase.
				testCasePassed := false.
				aTestCase recordRunFailedWith: signal.
				signal return: false]]
					on: self class error
					do:
						[:signal |
						errors add: aTestCase.
						testCasePassed := false.
						aTestCase recordRunFailedWith: signal.
						signal return: false].
	testCasePassed 
		ifTrue: [
			passed add: aTestCase.
			aTestCase recordRunWasSuccessful]! !

STracingTestCase subclass: #SCoverageTestCase
	instanceVariableNames: 'csTestRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage-Tests'!

SCoverageTestCase subclass: #SAsyncAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage-Tests'!

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 22:10:47.863'!
testRunInBackground

	SAsyncExampleTest resetCollectedMessages.
	self should: [ SAsyncExampleTest collectedMessagesAsString = '' ].
	
	self csTestRunner runSuite: SAsyncExampleTest exampleSuite.
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'Hello' ].
	
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: SAsyncExampleTest backgroundExampleSuite.
	(Delay forMilliseconds: 200) wait.
	SCoverageTestRunner sourceCodeAccessMonitor critical: [
		SAsyncExampleTest addMessage: 'World' ].
	
	self should: [ SAsyncExampleTest collectedMessagesAsString = 'HelloWorld' ].
	self csTestRunner disableRunningTestsInBackground.! !

!SAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:09.981'!
testRunningExampleSuite
	SAsyncExampleTest resetCollectedMessages.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).
	self should: [SAsyncExampleTest collectedMessagesAsString = 'Hello']. ! !

SCoverageTestCase subclass: #SBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage-Tests'!

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:35:09.172'!
testConcreteClassCoverage
	self deny: self exampleMethod hasMethodExtension.
	
	self tracePackage: self tbPackage.
	self runTbTests.
	
	self assert: [ self exampleMethod hasCoveringTestMethods ].
	self deny: [ (self exampleMethod coveringTestMethodsWhenReceiverWasOfKind: STbPerson) size = 0 ].! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.251'!
testCoverageApi
	| testMethod method |
	method := (STbPerson >> #firstname) clientMethod.
	testMethod := (STbPersonTest >> #testFirstnameAccessors) clientMethod.
	method 
		resetAllCoverageData;
		methodExtension: SNonTestMethodExtension new.
	method cstMethodExtension clientMethod: method.
		
	testMethod 
		resetAllCoverageData;
		methodExtension: STestMethodExtension new.
	testMethod cstMethodExtension clientMethod: testMethod.
	
	testMethod called: method receiver: nil.
	
	self should: [method hasCoveringTestMethods].
	self shouldnt: [testMethod hasCoveringTestMethods].
	self should: [method coveringTestMethods size = 1].
	self should: [method fixedTestMethods size = 0].
	self should: [method coveringAndNotFixedTestMethods size = 1].
	self should: [testMethod coveredMethods includes: method].
	self should: [testMethod coveredMethodsStatistics isEmpty not].
	
	method 
		resetAllCoverageData;
	 	resetMethodExtension.
	testMethod 
		resetAllCoverageData;
		resetMethodExtension.! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:33.04'!
testRetrievingTestsForMethod
	self tracePackage: self tbPackage.
	self runTbTests.
	self assert: (self exampleMethod coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.259'!
testRetrievingTestsForQuickReturnMethod
	self tracePackage: self tbPackage.
	self runTbTests.
	self assert: ((STbPerson>>#firstname) coveringTestMethods includes: STbPersonTest >> #testFirstnameAccessors).! !

!SCoverageTestCase class methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 18:30:44.675'!
shouldInheritSelectors
	^ false! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'mt 2/23/2011 17:47:44.325'!
createInstrumentor

	^ SWrappingInstrumentor new
		createExtensionBlock: self csTestRunner createExtensionBlock! !

!SCoverageTestCase methodsFor: 'accessing' stamp: 'bs 7/20/2010 22:54:27.907'!
csTestRunner
	^ csTestRunner ifNil: [ csTestRunner := SCoverageTestRunner new ]! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:37:51.8'!
runTbTests
	self runTestMethods: self tbTestMethods.! !

!SCoverageTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:37:29.852'!
runTestMethods: testMethods
	self csTestRunner runAndTraceTestMethods: testMethods.! !

SMethodExtension subclass: #SCstMethodExtension
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:28.733'!
instance
	^ Instance ifNil: [ Instance := super new ]! !

!SCstMethodExtension class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:32:16.96'!
new
	^ (self = SCstMethodExtension) 
		ifTrue: [ self instance ]
		ifFalse: [ super new ]! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:59:16.448'!
calledMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:38.556'!
coveredMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:48.841'!
coveredMethodsStatistics
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:48.206'!
coveringAndNotFixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:57:30.543'!
coveringTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:58:04.25'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ Array empty! !

!SCstMethodExtension methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:11:21.749'!
doesNotUnderstand: aMessage
	(self class subclasses anySatisfy: [ :c | c canUnderstand: aMessage selector ])
		ifFalse: [ self error: 'cst method extensions fail to support this message' ]! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/18/2010 12:15:50.529'!
fixedTestMethods
	^ Array empty! !

!SCstMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/18/2010 11:55:23.83'!
hasCoveringTestMethods
	^ false! !

!SCstMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/21/2010 15:43:07.799'!
hasFixedTestMethods
	^ false! !

!SCstMethodExtension methodsFor: 'accessing' stamp: 'bs 7/5/2010 08:35:48.717'!
pvtCodeSightMonitor
	^ SCodeSight sourceCodeMonitor! !

SCstMethodExtension subclass: #SNonTestMethodExtension
	instanceVariableNames: 'coverageTestRunner coveringTestMethods fixedTestMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/20/2010 17:38:57.471'!
beforeMethod

	self flag: #rkrk. "for benchmarking"
	coverageTestRunner runningTestMethod
		ifNotNilDo: [ :runningTestMethod |
			runningTestMethod called: self clientMethod ]! !

!SNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/20/2010 17:39:02.548'!
beforeMethodWithReceiver: anObject 
	coverageTestRunner runningTestMethod
		ifNotNilDo: [ :runningTestMethod |
			self calledBy: runningTestMethod receiverClass: anObject class ]! !

!SNonTestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/4/2010 21:20:00.58'!
calledBy: aTestMethod receiverClass: aClass 
	self pvtCoveringTestMethods add: aTestMethod.
	aTestMethod privateCovered: clientMethod withReceiverClass: aClass! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 7/20/2010 17:34:14.758'!
coverageTestRunner
	^ coverageTestRunner! !

!SNonTestMethodExtension methodsFor: 'accessing' stamp: 'mt 2/14/2011 14:08:06.126'!
coverageTestRunner: anObject

	coverageTestRunner := anObject.! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringAndNotFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtCoveringTestMethods copy.
		"fixed link might be established and coverage not yet"
		result removeAllFoundIn: self pvtFixedTestMethods ].
	^ result ! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:32'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods 
			select: [ :testMethod | 
				(testMethod privateStatisticsForCoveredMethod: self unwrappedMethod) 
					receiverClasses includes: aClass ] ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtFixedTestMethods copy ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixes: aCompiledTestMethod 
	self fixesAll: {aCompiledTestMethod}! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:10:15.679'!
fixesAll: compiledTestMethods 
	self pvtCodeSightMonitor critical: [
		compiledTestMethods do: [:ea | 
			self pvtFixedTestMethods add: ea.
			ea privateAddMethodThatFixedTest: clientMethod]. ].! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
hasCoveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/23/2010 20:38:13.259'!
hasFixed: aCompiledTestMethod 
	^ self fixedTestMethods includes: aCompiledTestMethod uninstrumentedMethod! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
hasFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtFixedTestMethods isEmpty not ].
	^ result! !

!SNonTestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:13:19.001'!
initialize
	super initialize.
	coveringTestMethods := KeyedIdentitySet
				keyBlock: [:t1 | t1 scaledIdentityHash]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
privateAddCoveringTestMethod: aCompiledTestMethod
	^ self pvtCoveringTestMethods add: aCompiledTestMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:29'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod ifAbsent: []! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:28:45.848'!
privateRemoveFixedTestMethod: aCompiledTestMethod
	self pvtFixedTestMethods remove: aCompiledTestMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:06:56.071'!
pvtCoveringTestMethods
	^ coveringTestMethods 
		ifNil: [ coveringTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/22/2010 10:15'!
pvtFixedTestMethods
	^ fixedTestMethods 
		ifNil: [fixedTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ]]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetCoveringTestMethods
	coveringTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetFixedTestMethods
	fixedTestMethods := nil! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self privateRemoveCoveringTestMethod: aTestCaseMethod ]! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/5/2010 11:23:36.774'!
removeFixedTestMethod: aTestMethod
	self pvtCodeSightMonitor critical: [
		aTestMethod privateRemoveMethodThatFixedTest: clientMethod.
		self pvtFixedTestMethods remove: aTestMethod. ]! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		(self pvtFixedTestMethods includes: aTestCaseMethod) ifFalse: [^ self].
		(self pvtCoveringTestMethods includes: aTestCaseMethod) ifTrue: [^ self].
		self pvtFixedTestMethods remove: aTestCaseMethod ]
	! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:10'!
resetAllCoverageData
	self 
		resetCoveringTestMethods;
		resetFixedTestMethods.! !

!SNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:11'!
resetCoveringTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtCoveringTestMethods do: [:testMethod |
			testMethod privateRemoveCoveredMethod: self unwrappedMethod ].
		self pvtResetCoveringTestMethods ].! !

!SNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:22:15.215'!
resetFixedTestMethods
	self pvtCodeSightMonitor critical: [
		self fixedTestMethods do: [:ea | 
			ea privateRemoveMethodThatFixedTest: clientMethod ].
		self pvtResetFixedTestMethods ].! !

SCstMethodExtension subclass: #STestMethodExtension
	instanceVariableNames: 'coveredMethodsStatistics calledMethods methodsThatFixedTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:53:25.565'!
called: aCompiledMethod

	self flag: #rkrk. "for benchmarking"
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { }  ]! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:52:43.762'!
called: aCompiledMethod receiver: anObject 
	
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { anObject class }  ].! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:51:41.557'!
called: aCompiledMethod receiverClasses: classes 

	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: classes ].! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:52'!
calledMethods
	^ calledMethods ifNil: [ calledMethods := OrderedIdentityCollection new  ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 8/5/2010 15:24:07.519'!
coveredMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics keys asIdentitySet ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:05'!
coveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics copy ].
	^ result! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 4/23/2010 10:34:11.8'!
hasCoveringTestMethods
	^ false! !

!STestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:12:21.388'!
initialize
	super initialize.
	coveredMethodsStatistics := OrderedKeysIdentityDictionary new! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/20/2010 17:01:22.063'!
methodsThatFixedTest
	^ self pvtCodeSightMonitor critical: [self pvtMethodsThatFixedTest copy]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 12:02:46.624'!
privateAddMethodThatFixedTest: aCompiledMethod
	self pvtMethodsThatFixedTest add: aCompiledMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 7/4/2010 21:19:49.989'!
privateCovered: aCompiledAppMethod withReceiverClass: aClass
	| statistic |
	statistic := self pvtCoveredMethodsStatistics 
				at: aCompiledAppMethod
				ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClass: aClass.
	self calledMethods add: aCompiledAppMethod.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:28'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:56:07.343'!
privateRemoveMethodThatFixedTest: aCompiledMethod
	self pvtMethodsThatFixedTest remove: aCompiledMethod ifAbsent: []! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:06'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self pvtCoveredMethodsStatistics at: aCompiledMethod ! !

!STestMethodExtension methodsFor: 'coverage tracing' stamp: 'bs 7/5/2010 11:33:21.544'!
pvtCalled: aCompiledMethod receiverClasses: classes 
	| statistic |
	aCompiledMethod privateAddCoveringTestMethod: self clientMethod.
		
	statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ STestStatistic new ].
	statistic addReceiverClasses: classes.! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:09:05.391'!
pvtCoveredMethodsStatistics
	^  coveredMethodsStatistics 
		ifNil: [ coveredMethodsStatistics := OrderedKeysIdentityDictionary new ]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 12:00:50.584'!
pvtMethodsThatFixedTest
	^ methodsThatFixedTest ifNil: [methodsThatFixedTest := IdentitySet new]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtResetCoveredMethodsStatistics
	coveredMethodsStatistics := nil! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:16:22.538'!
pvtResetMethodsThatFixedTest
	methodsThatFixedTest := nil! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
removeCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self privateRemoveCoveredMethod: aCompiledAppMethod ]! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 8/5/2010 11:20:42.474'!
removeMethodThatFixedTest: aMethod
	self pvtCodeSightMonitor critical: [
		aMethod privateRemoveFixedTestMethod: clientMethod.
		self pvtMethodsThatFixedTest remove: aMethod ifAbsent: [] ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:08'!
resetAllCoverageData
	self resetCoveredMethodsStatistics! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:46'!
resetCoveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics keysDo: [ :coveredMethod | 
				coveredMethod privateRemoveCoveringTestMethod: self unwrappedMethod. ].
	
		result := self pvtResetCoveredMethodsStatistics. 
		calledMethods := nil ].
	^ result! !

!STestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 7/29/2010 13:29:08.87'!
resetMethodsThatFixedTest
	self pvtCodeSightMonitor critical: [
		self methodsThatFixedTest do: [:ea | 
			ea privateRemoveFixedTestMethod: clientMethod ].
		self pvtResetMethodsThatFixedTest ]! !

!STestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:09'!
statisticsForCoveredMethod: aCompiledMethod 
	| result |
	self pvtCodeSightMonitor critical: [
		result := self privateStatisticsForCoveredMethod: aCompiledMethod  ].
	^ result! !

TestCase subclass: #SBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SBenchmarkTest class methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!SBenchmarkTest methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.265'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := STbPerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #SdCallgraphTests
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph-Tests'!

!SdCallgraphTests methodsFor: 'running' stamp: 'mt 7/16/2011 12:57:47.417'!
callGraphFor: aSelector

	tracer callgraph selectedCategories: {SdPersonTests category}.
	tracer traceTest: SdPersonTests method: aSelector.
	^ tracer callgraph! !

!SdCallgraphTests methodsFor: 'running' stamp: 'mt 7/16/2011 12:57:50.744'!
setUp

	super setUp.

	tracer := SdCallgraphTracer new.! !

!SdCallgraphTests methodsFor: 'sprint3' stamp: 'mt 7/16/2011 13:26:44.515'!
testDeepCopyOfFrame

	| objectBefore objectAfter graph |
	graph := self callGraphFor: #test02ChangingPerson.
	tracer collectProperties: #(receiverObjectBefore receiverObjectAfter) inNode: (graph at: 5).
	
	"before -> Fritz, after -> Frank"
	objectBefore := (graph at: 5) valueOfProperty: #receiverObjectBefore.
	objectAfter := (graph at: 5) valueOfProperty: #receiverObjectAfter.
	
	self assert: objectBefore class = SdTestPerson.
	self assert: objectBefore firstname = 'Fritz'.
	self assert: objectAfter class = SdTestPerson.
	self assert: objectAfter firstname = 'Frank'.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 14:29:37.036'!
testFindClassOfCall

	| graph |
	graph := self callGraphFor: #test01InitialFirstname.
	self assert: (graph at: 5) clientClass = SdTestPerson.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 18:33:42.531'!
testFindInitialization

	| initNode selectedNode graph |
	graph := self callGraphFor: #test06MultiplePersons.
	tracer collectShallowReturn.
	
	selectedNode := graph at: 15.
	initNode := graph detect: [:n | n isInstantiationOf: selectedNode].
	self assert: initNode id = 10.
	self assert: initNode clientSelector = #basicNew.

! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 15:01:30.781'!
testFindObjectIdOfCall

	| graph |
	graph := self callGraphFor: #test01InitialFirstname.
	self assert: (graph at: 5) receiverId isNumber.! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 16:46:55.571'!
testFindObjectInContext

	| graph nodes selectedNode |
	graph := self callGraphFor: #test07Siblings.
	tracer collectShallowContext.
	
	selectedNode := graph at: 5. "Tim"
	nodes := graph select: [:n | n isInContextWith: selectedNode].
	self assert: nodes size = (2 "basicNew (retVal), initialize (self)" +
								  1 "firstname: (self)" +
								  1 "sibling: (argument)" +
								  1 "firstname (instVar)").
	#(basicNew initialize firstname: sibling: firstname) withIndexDo: [:s :idx |
		self assert: (nodes at: idx) clientSelector = s].
! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:46:55.64'!
testFindObjectInContextMultipleTimes

	| graph timNode1 timNode2 struppiArgTimNode |
	graph := self callGraphFor: #test05MultiContext.
	tracer collectShallowContext.
	
	timNode1 := graph find: #firstname: callOn: SdTestPerson number: 1. "tim firstname: 'Tim'."
	timNode2 := graph find: #firstname callOn: SdTestPerson number: 1. "tim firstname."

	struppiArgTimNode := graph find: #sibling: callOn: SdTestPerson number: 2. "struppi sibling: tim."
	self assert: (struppiArgTimNode isInContextWith: timNode1).
	self assert: (struppiArgTimNode isInContextWith: timNode2).
	self assert: (struppiArgTimNode globalArgumentIds first) = timNode1 globalReceiverId.
	self assert: (struppiArgTimNode globalArgumentIds first) = timNode2 globalReceiverId.! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:46:55.711'!
testFindObjectInContextWithoutDestroyingReceiverId

	| graph nodes selectedNode oldRecvId |
	graph := self callGraphFor: #test07Siblings.
	tracer collectShallowContext.
	
	selectedNode := graph at: 6.
	oldRecvId := selectedNode receiverId.
	nodes := graph select: [:n | n isInContextWith: selectedNode].
	self assert: (graph at: 6) receiverId = oldRecvId.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 16:38:00.585'!
testFindOrderOfObject

	| graph |
	graph := self callGraphFor: #test06MultiplePersons.
	self assert: (graph at: 13) receiverId = 3.! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:45.905'!
testFindReadsOfObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isReadOf: selectedNode].
	self assert: nodes size = 2.
	self assert: nodes first clientSelector = #firstname.
	self assert: nodes second clientSelector = #firstname.

! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:50.257'!
testFindSendsToObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isSameObjectAs: selectedNode].
	self assert: nodes size = 5.
	#(initialize firstname: firstname #nameAsScienceFictionHero firstname)
		withIndexDo: [:selector :index |
			self assert: (nodes at: index) clientSelector = selector].
! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:58.606'!
testFindWritesToObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isWriteTo: selectedNode].
	self assert: nodes size = 2.
	self assert: nodes first clientSelector = #initialize.
	self assert: nodes second clientSelector = #firstname:.
! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:42:00.756'!
testFindingObjects
	| graph node1 node2 node3 node4 |
	graph := self callGraphFor: #test04MultiCalls.
	node1 := graph at: 5. "tim firstname: 'Tim'."
	node2 := graph at: 6. "tim firstname."
	node3 := graph at: 7. "tim firstname."
	"graph at: 9. Person basicNew"
	"graph at: 10. struppi initialize"
	node4 := graph at: 10. "struppi firstname."

	self assert: node1 = (graph find: #firstname: callOn: SdTestPerson number: 1).
	self assert: node2 = (graph find: #firstname callOn: SdTestPerson number: 1).
	self assert: (graph findAll: #firstname callsOn: SdTestPerson number: 1) size = 2.
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 1) includes: node3).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 1) includes: node2).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 2) size = 1).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 2) includes: node4).
	self assert: node4 = (graph find: #firstname callOn: SdTestPerson number: 2).! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:44:10.653'!
testInstanceCountDoesNotChangeOnRetrace
	
	| graph node previousReceiverId |
	graph := self callGraphFor: #test05MultiContext.

	node := graph find: #firstname: callOn: SdTestPerson number: 1. "tim firstname: 'Tim'."
	previousReceiverId := node receiverId.

	tracer trace. "again"

	self assert: node receiverId = previousReceiverId.
	self assert: (graph find: #firstname: callOn: SdTestPerson number: 1) receiverId = previousReceiverId.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 16:45:06.714'!
testMultipleInstances

	|instances klass graph |
	graph := self callGraphFor: #test06MultiplePersons.  
	klass := (graph at: 5) receiverClass.
	instances := graph select: [:node | node isInstantiationOf: klass].
	self assert: instances size = 3.
	instances do: [ :item | self assert: item receiverClass theNonMetaClass = SdTestPerson].

! !

TestCase subclass: #SdPersonTests
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph-Testbed'!

!SdPersonTests commentStamp: 'mt 7/16/2011 13:21:22.282' prior: 0!
The behavior of these tests influence SdCallgraphTests as the resulting call graphs are tested.!

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:40:28.773'!
test01InitialFirstname

	self assert: SdTestPerson new firstname notNil.
	! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:41:20.09'!
test02ChangingPerson

	| person |
	person := SdTestPerson new.
	person firstname: 'Frank'.
	person firstname: 'Not Frank'.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:41:41.033'!
test03FamilyName

	| frank fritz |
	
	frank := SdTestPerson new firstname: 'Frank'.
	fritz := SdTestPerson new.

	fritz connect: frank signal: #lastNameChanged: toSelector: #lastname:.

	self
		assert: 'Foo' equals: frank lastname;
		assert: 'Foo' equals: fritz lastname.
	
	frank lastname: 'Bar'.
	  
	self
		assert: 'Bar' equals: frank lastname;
		assert: 'Bar' equals: fritz lastname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:42:09.37'!
test04MultiCalls

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	tim firstname.
	tim firstname.
	struppi := SdTestPerson new.
	struppi firstname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:42:41.665'!
test05MultiContext

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	tim firstname.
	struppi := SdTestPerson new.
	struppi firstname: 'Struppi'.
	struppi sibling: tim.
	self assert: 'Struppi' equals: struppi firstname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 14:29:58.317'!
test06MultiplePersons

	| default frank tim customer |

	default := SdTestPerson new.
	self assert: default firstname = 'Fritz'.

	frank := SdTestPerson new.
	frank firstname: 'Frank'.
	self assert: frank firstname = 'Frank'.
	
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	self assert: tim firstname = 'Tim'.
	tim nameAsScienceFictionHero.
	self assert: frank nameAsScienceFictionHero = 'Frankainous'.
	
	customer := SdTestCustomer new.
	customer firstname: 'John'.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:43:20.899'!
test07Siblings

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	struppi := SdTestPerson new.
	struppi firstname: 'Struppi'.
	struppi sibling: tim.
	self assert: struppi firstname = 'Struppi'.! !

!TestCase methodsFor: '*Sight-Cst' stamp: 'bs 7/20/2010 18:08:23.976'!
recordRunFailedWith: anException
	self selectedMethod testFailedWith: anException.
	
	! !

!TestCase methodsFor: '*Sight-Cst' stamp: 'bs 7/20/2010 18:08:20.353'!
recordRunWasSuccessful
	self selectedMethod testWasSuccessful! !

!TestCase methodsFor: '*Sight-Cst' stamp: 'bs 7/20/2010 18:07:57.774'!
selectedMethod
	^ self class >> self selector! !

!Symbol methodsFor: '*Sight-Cst' stamp: 'bs 9/10/2009 08:54'!
isTestSelector
	^ (self last ~= $:) and: ['test*' match: self]! !

SEventHandler subclass: #SCoverageEventHandler
	instanceVariableNames: 'coverageTestRunner'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:18:28.911'!
classRemoved: aRemovedEvent
	aRemovedEvent item isTestCaseClass 
		ifTrue: [ 
			aRemovedEvent item testMethods do: [ :ea | 
				self coverageTestRunner testMethodRemoved: ea ] ]! !

!SCoverageEventHandler methodsFor: 'accessing' stamp: 'bs 7/20/2010 23:10:55.523'!
coverageTestRunner
	^ coverageTestRunner! !

!SCoverageEventHandler methodsFor: 'accessing' stamp: 'mt 2/14/2011 14:08:01.229'!
coverageTestRunner: anObject

	coverageTestRunner := anObject.! !

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 8/6/2010 11:55:18.563'!
methodModified: aModifiedEvent
	aModifiedEvent item isTestMethod 
		ifTrue: [ 
			self coverageTestRunner 
				testMethodModifiedFrom: aModifiedEvent oldItem
				to: aModifiedEvent item ]! !

!SCoverageEventHandler methodsFor: 'system event handling' stamp: 'bs 7/20/2010 23:18:21.163'!
methodRemoved: aRemovedEvent
	aRemovedEvent item isTestMethod
		ifTrue: [ 
			self coverageTestRunner testMethodRemoved: aRemovedEvent item ]! !

SEventHandler subclass: #SReplicaCommandCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicaCommandCreator methodsFor: 'system event handling' stamp: 'bs 1/28/2010 21:29:26.234'!
classAdded: anAddedEvent! !

SEventHandler subclass: #SReplicaService
	instanceVariableNames: 'listenSocket servingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.695'!
receiveAndProcess: aSocket
	| receivedMessage |
	receivedMessage := SReplicateMessage receiveFrom: aSocket.
	receivedMessage applyCommand.
	self codeSight 
		ifNotNil: [ self codeSight csTestRunner result copy ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 08:59:23.349'!
runLoop
	"Run the server's connection accept loop."
	| newConnectionSocket |
	
	[listenSocket isValid]
		whileTrue: 
			[[newConnectionSocket := listenSocket waitForAcceptFor: 10]
				on: ConnectionTimedOut
				do: [:ex | newConnectionSocket := nil].
			 newConnectionSocket isNil
				ifFalse:
					[ self serve: newConnectionSocket ] ]! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:40.687'!
serve: aSocket
	| receivedMessage |
	[aSocket isValid and: [aSocket isConnected] ] 
		whileTrue: [
			aSocket waitForDataIfClosed: [ ].
			receivedMessage := SReplicateMessage receiveFrom: aSocket.
			receivedMessage applyCommand ] 
	! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 16:38:39.339'!
servicePriority
	^ Processor lowIOPriority! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 09:43:23.521'!
startOn: portNumber
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: portNumber backlogSize: 2.
	listenSocket isValid ifFalse: [^self error: 'Could not create server socket'].
	servingProcess := [self runLoop] forkAt: self servicePriority.! !

!SReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 19:21:28.985'!
stop
	servingProcess terminate.
	listenSocket closeAndDestroy.! !

SEventHandler subclass: #SReplicator
	instanceVariableNames: 'replicaName servicePort clientSocket replicaProcess actorId'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:14.991'!
existsInstanceWithName: aName orPort: anInteger
	^ self instances 
		anySatisfy: [ :aReplicator | 
			(aReplicator replicaName = aName) 
				or: [ aReplicator servicePort = anInteger ] ]! !

!SReplicator class methodsFor: 'class initialization' stamp: 'bs 1/27/2010 22:08:28.259'!
initialize
	" self initialize "
	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!SReplicator class methodsFor: 'accessing' stamp: 'bs 2/8/2010 18:14:39.907'!
instances
	" Instances := nil "
	^ Instances ifNil: [ Instances := WeakSet new ]! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 1/27/2010 22:29:37.5'!
new
	self error: 'only use newWithReplicaName: '! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:09.773'!
newMaintenanceReplica
	^ self newMaintenanceReplicaOnPort: 9998.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:15.342'!
newMaintenanceReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'maintenance'
		servingOnPort: anInteger.! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:49.034'!
newReplicaNamed: aName servingOnPort: anInteger
	(self existsInstanceWithName: aName orPort: anInteger)
		ifTrue: [ self error: ('there already exists a replicated image ',
					'with name: {1} or port: {2}' format: {aName asString. anInteger asString}) ].
	
	^ self instances add: ( 
		super new 
			replicaName: aName; 
			servicePort: anInteger;
			yourself ).
			! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:40.482'!
newTestReplica
	^ self newTestReplicaOnPort: 9999! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:10.667'!
newTestReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'testFeedback'
		servingOnPort: anInteger! !

!SReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:04:59.818'!
remove: aReplicator
	self instances remove: aReplicator ifAbsent: []! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:02:26.951'!
categoryAdded: anAddedEvent
	| categoryName |
	categoryName := anAddedEvent item.
	^ 'Smalltalk organization addCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:49:16.088'!
categoryRemoved: aRemovedEvent
	| categoryName |
	categoryName := aRemovedEvent item.
	^ 'Smalltalk organization removeCategory: ''{1}''' format: {categoryName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:50:29.154'!
categoryRenamed: aRenamedEvent

	^ 'Smalltalk organization renameCategory: ''{1}'' toBe: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName.}! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:52.584'!
changeExtension
	^ self extensionForSuffix: FileDirectory changeSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:24.896'!
classAdded: anAddedEvent
	^ self classAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:08.601'!
classAddedOrModified: anEvent
	| addedOrModifiedClass | 
	addedOrModifiedClass := anEvent item.
	^ addedOrModifiedClass definition.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:48:24.449'!
classModified: aModifiedEvent
	^ self classAddedOrModified: aModifiedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 19:26:21.287'!
classRecategorized: aRecategorizedEvent
	| aClass |
	aClass := aRecategorizedEvent item.
	^ '{1} category: ''{2}''' format: {aClass. aClass category}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:13:32.5'!
classRemoved: aRemovedEvent
	| removedClass | 
	removedClass := aRemovedEvent item.
	^ '{1} removeFromSystem' format: {removedClass name}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 17:24:47.292'!
classRenamed: aRenamedEvent

	^ '{1} rename: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 20:01:02.201'!
classReorganized: aReorganizedEvent
	| aClass |
	aClass := aReorganizedEvent item.
	^ '{1} do: [ :eachCategory | {2} organization addCategory: eachCategory ]'
		format: {aClass organization categories. aClass}! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/23/2010 13:49:48.655'!
createAndStartReplica
	self 
		createCopyOfThisImage;
		startReplicaInNewProcess! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:08:22.907'!
createCopyOfThisImage
	
	self deleteReplicaImage.
	
	self squeakFileExtensions do: [ :extension | 
		FileDirectory default
			copyFileNamed: self nameOfThisImage, extension 
			toFileNamed: self nameOfReplicaImage, extension. ].! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:09:31.959'!
deleteReplicaImage

	self squeakFileExtensions do: [ :extension | 
		FileDirectory default 
			deleteFileNamed: self nameOfReplicaImage, extension ifAbsent: [] ]! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:29:49.375'!
extensionForSuffix: aSuffix
	^ FileDirectory dot, aSuffix
	! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:47.418'!
imageExtension
	^ self extensionForSuffix: FileDirectory imageSuffix.! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:10.971'!
methodAdded: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 13:35:06.984'!
methodAddedOrModified: anEvent
	| source sourceWithDoubleEscapedStrings |
	source := anEvent item getSource asString.
	sourceWithDoubleEscapedStrings := source copyReplaceAll: '''' with: ''''''.
	^ '{1} compile: ''{2}''' 
		format: {anEvent itemClass. sourceWithDoubleEscapedStrings}! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:18.132'!
methodModified: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!SReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 12:50:29.172'!
methodRemoved: aRemovedEvent
	^ '{1} removeSelector: #{2}' 
		format: {aRemovedEvent itemClass. aRemovedEvent itemSelector}! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/26/2010 22:05:12.719'!
nameOfReplicaImage
	^ self nameOfThisImage, '-replicated-', self replicaName! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:57.122'!
nameOfThisImage
	| imageFilePath imageFileName |
	imageFilePath := SmalltalkImage current imageName.
	imageFileName := self workingDirectory localNameFor: imageFilePath.
	^ FileDirectory baseNameFor: imageFileName.	! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 18:40:52.767'!
parentProcessId
	^ ThisOSProcess thisOSProcess ppid.! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:24:46.072'!
replicaImageName
	^ self nameOfReplicaImage! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:32:03.545'!
replicaImagePath
	^ self workingDirectory fullNameFor: (self replicaImageName, self imageExtension)! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.519'!
replicaName
	^ replicaName! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.52'!
replicaName: anObject
	replicaName := anObject! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.076'!
replicaProcess
	^ replicaProcess! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.077'!
replicaProcess: anObject
	replicaProcess := anObject! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 21:30:34.71'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.275'!
servicePort
	^ servicePort! !

!SReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.276'!
servicePort: anObject
	servicePort := anObject! !

!SReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:31:15.856'!
squeakFileExtensions
	^ { self imageExtension. self changeExtension } ! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 3/2/2010 21:42:11.538'!
startReplicaInNewProcess
	| squeakVmPath |
	squeakVmPath := OSProcess programName.
	self replicaProcess: (
		ExternalOSProcess concreteClass 
			programName: squeakVmPath 
			arguments: { "'-headless'." self replicaImagePath. } 
			initialEnvironment: nil ).
	self replicaProcess value.! !

!SReplicator methodsFor: 'start / stop' stamp: 'bs 2/25/2010 10:56:34.6'!
stopReplicaAndCleanUp
	self class remove: self.
	self 
		stopReplicaProcess;
		deleteReplicaImage! !

!SReplicator methodsFor: 'start / stop' stamp: 'replica 2/24/2010 22:09:37.556'!
stopReplicaProcess
	self replicaProcess 
		ifNotNil: [ self replicaProcess terminate ].
	! !

!SReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:41.204'!
workingDirectory
	^ FileDirectory default! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:46:25.893'!
called: aCompiledMethod
	self cstMethodExtension called: aCompiledMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:46:36.386'!
called: aCompiledMethod receiver: anObject 
	self cstMethodExtension called: aCompiledMethod receiver: anObject ! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:46:43.765'!
called: aCompiledMethod receiverClasses: classes 
	self cstMethodExtension called: aCompiledMethod receiverClasses: classes ! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:46:48.272'!
coveredMethods
	^ self cstMethodExtension coveredMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:46:55.863'!
coveredMethodsStatistics
	^ self cstMethodExtension coveredMethodsStatistics! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:00.904'!
coveringAndNotFixedTestMethods
	^ self cstMethodExtension coveringAndNotFixedTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:05.66'!
coveringTestMethods
	^ self cstMethodExtension coveringTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:09.466'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ self cstMethodExtension coveringTestMethodsWhenReceiverWasOfKind: aClass ! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 3/3/2011 13:40:31.199'!
cstMethodExtension
	^ self hasMethodExtension
		ifTrue: [self methodExtension]
		ifFalse: [
			" return always an empty method extension "
			self isTestMethod 
				ifTrue: [ STestMethodExtension new ]
				ifFalse: [ SNonTestMethodExtension new ]]
	! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/31/2009 16:27'!
failedExpression
	| interval |
	interval := self failedExpressionInterval.
	^ self getSource asString copyFrom: interval first to: interval last.! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/31/2009 16:06'!
failedExpressionInterval
	^ self properties at: #codeSightFailedExpression ifAbsent: [ nil ]! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/31/2009 16:19'!
failedExpressionInterval: aSelectionInterval
	self properties at: #codeSightFailedExpression put: aSelectionInterval.! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/22/2009 18:24'!
findTestMethodInStack: anException
	^ anException signalerContext contextStack 
		detect: [:aMethodContext | aMethodContext method = self]
		ifNone: [nil]! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:16.202'!
fixedTestMethods
	^ self cstMethodExtension fixedTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:24.027'!
fixes: aCompiledTestMethod 
	^ self cstMethodExtension fixes: aCompiledTestMethod ! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 11:47:28.202'!
fixesAll: compiledTestMethods
	^ self cstMethodExtension fixesAll: compiledTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:00:26.133'!
hasCoveringTestMethods
	^ self cstMethodExtension hasCoveringTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 8/23/2010 20:37:19.438'!
hasFixed: aCompiledTestMethod 
	^ self cstMethodExtension hasFixed: aCompiledTestMethod ! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/21/2010 15:42:35.534'!
hasFixedTestMethods
	^ self cstMethodExtension hasFixedTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/21/2009 15:58'!
hasTestFailed
	^ self properties includesKey: #codeSightFailedExpression
	! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 11/27/2009 10:41'!
isTestMethod
	^ (self methodClass inheritsFrom: TestCase) and: [self selector isTestSelector]! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/29/2010 12:09:19.708'!
methodsThatFixedTest 
	^ self cstMethodExtension methodsThatFixedTest! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:07'!
newTestCase
	self assert: [ self isTestMethod ].
	
	^ self methodClass selector: self selector.! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 11/27/2009 11:05'!
overriddenAndOverridingMethods
	^ self overriddenAndOverridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'test 9/20/2009 21:39'!
overriddenAndOverridingMethodsIn: aClass
	|result|
	result := (self overridingMethodsIn: aClass) copy.
	(self overriddenMethodIn: aClass) 
		ifNotNilDo: [:aMethod | result add: aMethod].
	^ result! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'test 9/20/2009 21:34'!
overriddenMethod
	^ self overriddenMethodIn: self methodClass! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 3/3/2011 14:54:46.057'!
overriddenMethodIn: aClass
	^ (aClass superclass whichClassIncludesSelector: self selector)
			ifNotNilDo: [ :superclass | (superclass >> self selector) clientMethod ]
			ifNil: [ nil ].! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'test 9/20/2009 21:34'!
overridingMethods
	^ self overridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 3/3/2011 14:56:38.47'!
overridingMethodsIn: aClass
	| overriders |
	overriders := Set new.
	self methodClass addOverridersOf: self selector to: overriders.
	
	^ overriders collect: [ :overrider | (overrider >> self selector) clientMethod ]! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:00:41.683'!
privateAddCoveringTestMethod: aCompiledTestMethod
	self cstMethodExtension privateAddCoveringTestMethod: aCompiledTestMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/29/2010 13:10:42.311'!
privateAddMethodThatFixedTest: aCompiledAppMethod
	^ self cstMethodExtension privateAddMethodThatFixedTest: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:00:48.316'!
privateCovered: aCompiledAppMethod withReceiverClass: aClass
	self cstMethodExtension privateCovered: aCompiledAppMethod withReceiverClass: aClass! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:00:53.065'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self cstMethodExtension privateRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:10.502'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	self cstMethodExtension privateRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/29/2010 13:28:56.554'!
privateRemoveFixedTestMethod: aCompiledTestMethod
	^ self cstMethodExtension privateRemoveFixedTestMethod: aCompiledTestMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/29/2010 13:22:51.191'!
privateRemoveMethodThatFixedTest: aCompiledAppMethod
	^ self cstMethodExtension privateRemoveMethodThatFixedTest: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:24.333'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self cstMethodExtension privateStatisticsForCoveredMethod: aCompiledMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:31'!
pvtCodeSightMonitor! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:31'!
pvtCoveredMethodsStatistics! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:31'!
pvtCoveringTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:31'!
pvtFixedTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:28.592'!
removeCoveredMethod: aCompiledAppMethod
	^ self cstMethodExtension removeCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:32.717'!
removeCoveringTestMethod: aTestCaseMethod
	^ self cstMethodExtension removeCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 8/5/2010 11:23:59.697'!
removeFixedTestMethod: aTestMethod
	^ self cstMethodExtension removeFixedTestMethod: aTestMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:36.814'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	^ self cstMethodExtension removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 8/5/2010 11:21:25.823'!
removeMethodThatFixedTest: aMethod
	^ self cstMethodExtension removeMethodThatFixedTest: aMethod! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 3/2/2011 21:01:21.773'!
resetAllCoverageData
	^ self resetMethodExtension! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 3/2/2011 21:55:36.314'!
resetCoveredMethodsStatistics
	"the methodExtension is nil, if the test (method) is executed,
	but the code (including this method) is not instrumented"
	self cstMethodExtension ifNotNil: [:ea | ea resetCoveredMethodsStatistics]! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:45.467'!
resetCoveringTestMethods
	^ self cstMethodExtension resetCoveringTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/21/2009 12:57'!
resetFailedExpression
	self properties removeKey: #codeSightFailedExpression ifAbsent: [].! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:49.949'!
resetFixedTestMethods
	^ self cstMethodExtension resetFixedTestMethods! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/29/2010 12:09:01.589'!
resetMethodsThatFixedTest 
	^ self cstMethodExtension resetMethodsThatFixedTest! !

!CompiledMethod methodsFor: '*Sight-Cst' stamp: 'bs 7/18/2010 12:01:54.528'!
statisticsForCoveredMethod: aCompiledMethod 
	^ self cstMethodExtension statisticsForCoveredMethod: aCompiledMethod ! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/31/2009 16:24'!
testFailedWith: anException
	| testMethodContext pc pcRange | 
	testMethodContext := self findTestMethodInStack: anException.
	testMethodContext
		ifNotNil: [
			pc := testMethodContext pc.
			pcRange := testMethodContext debuggerMap 
				rangeForPC: pc contextIsActiveContext: false.
			self failedExpressionInterval: pcRange ].! !

!CompiledMethod methodsFor: '*Sight-Cst-FailedExpression' stamp: 'bs 12/21/2009 15:51'!
testWasSuccessful
	self resetFailedExpression! !

CompiledMethod variableByteSubclass: #SInstrumentedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 8/10/2010 15:26:16.334'!
activateBefore: methodIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: methodIndex.
	aMethodExtension codeSight csTestRunner activateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.264'!
activationOn: aSelectorSymbol inClass: aClass
	| originalMethod decompiledMethodNode methodNode aroundCodeNode wrappedStatements statementToAdd instrumentedMethod originalStatements |
	
	originalMethod := aClass >> aSelectorSymbol.
	decompiledMethodNode := originalMethod decompile.
	decompiledMethodNode instVarNamed: 'properties' put: nil.
	methodNode := Parser new parse: decompiledMethodNode asString class: aClass.
	
	aroundCodeNode := self createActivationAroundCodeFor: originalMethod.
	wrappedStatements := aroundCodeNode "return" expr "ensure" receiver "block" statements. 
	
	originalStatements := methodNode body statements copy.
	methodNode body statements removeAll: originalStatements.
	
	originalStatements do: [  :st | 
		statementToAdd := (st isKindOf: ReturnNode) ifTrue: [ st expr ] ifFalse: [ st ] .
		wrappedStatements add: statementToAdd ].
	
	methodNode body statements addFirst: aroundCodeNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.281'!
createActivationAroundCodeFor: aCompiledMethod
	| extIndex aroundCode aroundCodeMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	aroundCode := 
		'^ [',
			'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
			'     codeSight activateTracing.',
		'] ensure: [',
			'(' , SWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
			'     codeSight deactivateTracing.',
		']'.
	
	aroundCodeMethodNode := Parser new parse: 'foo ', aroundCode class: Object.
	^ aroundCodeMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:47:12.289'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , SWeavingInstrumentor asString , ' calleeAtIndex: ' , extIndex asString , ')' ,
		'     calledByRunningTestWithReceiver: self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!SInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 8/10/2010 15:27:38.78'!
deactivateAfter: calleeIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := SWeavingInstrumentor extensionAtIndex: calleeIndex.
	aMethodExtension codeSight csTestRunner deactivateTracing.! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 11:42:57.148'!
on: aSelectorSymbol inClass: aClass
	| originalMethod methodNode traceCallNode instrumentedMethod |
	
	originalMethod := aClass >> aSelectorSymbol.
	methodNode := self parseSource: originalMethod.
	
	traceCallNode := self createTraceCallFor: originalMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!SInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.325'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.15'!
clientMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.162'!
compiledMethod
	^ self originalMethod! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.218'!
install
	self methodClass addSelectorSilently: self selector withMethod: self.! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.173'!
methodExtension
	^ self originalMethod methodExtension! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.184'!
methodExtension: anObject
	^ self originalMethod methodExtension: anObject! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.195'!
originalMethod
	^ self properties at: #codeSightOriginalMethod ifAbsent: [ nil ]! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.207'!
originalMethod: aCompiledMethod
	self properties at: #codeSightOriginalMethod put: aCompiledMethod! !

!SInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 8/17/2010 19:50:42.706'!
resetMethodExtension
	self originalMethod resetMethodExtension! !

!SInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.229'!
uninstall
	(self methodClass includesSelector: self selector)
		ifTrue: [
			 self methodClass 
				addSelectorSilently: self selector 
				withMethod: self originalMethod. ]! !

TextAttribute subclass: #STextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Ui-Text'!

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color
	^ color! !

!STextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color: anObject
	color := anObject! !

!STextBackgroundColor methodsFor: 'displaying' stamp: 'bs 12/21/2009 17:03'!
emphasizeBackground: bounds on: aCanvas
	aCanvas 
		fillRectangle: bounds
		color: self color.! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/21/2009 17:34'!
shoutShouldPreserve
	^ true! !

!STextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 18:22'!
writeScanOn: strm
	! !

!TextAttribute methodsFor: '*Sight-Cst' stamp: 'bs 12/21/2009 17:01'!
emphasizeBackground: bounds on: aCanvas
	"Subclasses may override"! !

!MethodNode methodsFor: '*Sight-Cst' stamp: 'bs 3/4/2010 22:53:54.075'!
generate: trailer using: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	| literals blkSize method nArgs nLits primErrNode stack strm |
	self generate: trailer ifQuick: 
		[:m |
		literals := encoder allLiterals.
		(nLits := literals size) > 255 ifTrue:
			[^self error: 'Too many literals referenced'].
		1 to: nLits do: [:lit | m literalAt: lit put: (literals at: lit)].
		m properties: properties.
		^m].
	primErrNode := self primitiveErrorVariableName ifNotNil:
						[encoder fixTemp: self primitiveErrorVariableName].
	nArgs := arguments size.
	blkSize := (block sizeForEvaluatedValue: encoder)
				+ (primErrNode ifNil: [0] ifNotNil: [2 "We force store-long (129)"]).
	(nLits := (literals := encoder allLiterals) size) > 255 ifTrue:
		[^self error: 'Too many literals referenced'].
	
	method := aCompiledMethodClass	"Dummy to allocate right size"
				newBytes: blkSize
				trailerBytes: trailer 
				nArgs: nArgs
				nTemps: encoder maxTemp
				nStack: 0
				nLits: nLits
				primitive: primitive.
	strm := ReadWriteStream with: method.
	strm position: method initialPC - 1.
	stack := ParseStack new init.
	primErrNode ifNotNil: [primErrNode emitStore: stack on: strm].
	block emitForEvaluatedValue: stack on: strm.
	stack position ~= 1 ifTrue:
		[^self error: 'Compiler stack discrepancy'].
	strm position ~= (method size - trailer size) ifTrue:
		[^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size.
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	method properties: properties.
	^method! !

!MethodNode methodsFor: '*Sight-Cst' stamp: 'bs 3/4/2010 22:24:39.64'!
generateUsing: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."
	
	^ self generate: CompiledMethodTrailer empty using: aCompiledMethodClass! !

Actor subclass: #SActor
	instanceVariableNames: 'codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.096'!
codeSight
	^ codeSight! !

!SActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.097'!
codeSight: anObject
	codeSight := anObject! !

!SActor methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 21:20:59.344'!
recipient
	^ self codeSight! !

STbTestCase subclass: #SAsyncExampleTest
	instanceVariableNames: 'csTestRunner'
	classVariableNames: 'CollectedMessages'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage-Tests'!

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 22:11:00.634'!
addMessage: aString
	self collectedMessages add: aString.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:43'!
backgroundExampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testRunExampleInBackground).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 22:11:17.909'!
collectedMessages
	^ CollectedMessages ifNil: [CollectedMessages := OrderedCollection new.]! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 22:11:27.387'!
collectedMessagesAsString
	| stream |
	stream := WriteStream with: String new.
	self collectedMessages do: [: elem | stream nextPutAll: elem].
	^ stream contents! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
exampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testExample).
	^ aSuite.! !

!SAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 21:38:11.041'!
resetCollectedMessages
	CollectedMessages := nil.! !

!SAsyncExampleTest methodsFor: 'running' stamp: 'bs 8/19/2010 22:10:09.848'!
csTestRunner
	^ csTestRunner ifNil: [csTestRunner := SCoverageTestRunner new]! !

!SAsyncExampleTest methodsFor: 'running' stamp: 'bs 8/19/2010 22:09:40.16'!
setUp
	super setUp! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:36'!
testExample
	self class addMessage: 'Hello'! !

!SAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 21:44:38.432'!
testRunExampleInBackground
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: (SAsyncExampleTest exampleSuite).! !

STbTestCase subclass: #SCstTestCase
	instanceVariableNames: 'registeredPackages unregisteredPackages tddAutoRunTestRunner codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight
	^ codeSight! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight: anObject
	codeSight := anObject! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 7/4/2010 12:48:15.208'!
codeSightClass
	^ SCodeSight! !

!SCstTestCase methodsFor: 'running' stamp: 'mt 2/23/2011 17:48:58.087'!
createInstrumentor

	^ SWrappingInstrumentor new! !

!SCstTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 13:56:54.841'!
createSuperCallTestCode
	^ 'testSuperCall', String crlf, String tab, 'STbPersonSubclass new asString'.! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ self codeSight csTestRunner! !

!SCstTestCase methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:40'!
instrumentor
	^ self codeSight instrumentor! !

!SCstTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 17:43:22.73'!
removeMethod: aMethod
	super removeMethod: aMethod uninstrumentedMethod! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 7/12/2010 20:23:54.506'!
resetTbPackage
	self tbClasses do: [ :aClass | 
		aClass methodDict values do: [ :method | method resetMethodExtension ] ].! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 18:42:12.34'!
runTbTests
	self runTestMethods: self tbTestMethods.! !

!SCstTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 18:38:47.762'!
runTestMethods: testMethods
	self csTestRunner runAndTraceTestMethods: testMethods.! !

!SCstTestCase methodsFor: 'running' stamp: 'mt 2/14/2011 14:02:25.324'!
setUp
	super setUp.
	self resetTbPackage.
	
	self codeSight: self codeSightClass new.
	self tracePackage: self tbPackage.
	self csTestRunner isInTddAutoRunMode: true.! !

!SCstTestCase methodsFor: 'running' stamp: 'mt 2/14/2011 14:03:02.294'!
tearDown
	self csTestRunner 
		isInTddAutoRunMode: false;
		disableRunningTestsInBackground.
	
	self removeAddedInstAndClassVars.
	self codeSight cleanUp.
	self codeSight: nil.
	self resetTbPackage.
	super tearDown.! !

!SCstTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 11:27:18.337'!
tracePackage: aPackageInfo
	(self codeSight managedPackages includes: aPackageInfo)
		ifFalse: [ self codeSight addToManagedPackages: aPackageInfo ]! !

SCstTestCase subclass: #SDistributionRequestTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution-Tests'!

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:16.027'!
codeSightClass
	^ SCodeSightForDistributionRequestTests! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 15:25:33.704'!
testRequestForCoverageMaintenance
	| testMethodsToRun testMethodNames actor coverageData |
	testMethodsToRun := { self exampleTestMethod }.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self csTestRunner activateTracing.
	self codeSight maintainCoverage: testMethodNames.
	
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestCoverage isEmpty ].
	coverageData := actor receivedTestCoverage at: self exampleTestMethod qualifiedName.
	self should: [ (coverageData at: self exampleMethod qualifiedName) includes: STbPerson name ].
	! !

!SDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.451'!
testRequestForTesting
	| testMethodsToRun testMethodNames actor |
	testMethodsToRun := STbPersonTest testMethods.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight runTests: testMethodNames.
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestResult passed isEmpty ].
	self shouldnt: [ actor receivedTestResult failures isEmpty ].! !

SCstTestCase subclass: #SDistributionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution-Tests'!

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/25/2010 08:27:21.659'!
createExampleCoverageData
	| testsToCoverageData coverageData | 
	testsToCoverageData := Dictionary new.
	coverageData := testsToCoverageData 
			at: self exampleTestMethod qualifiedName
			put: Dictionary new.
	coverageData 
		at: (self exampleMethod qualifiedName)
		put: {self exampleMethod methodClass name}.
	
	^ testsToCoverageData.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:33.087'!
createExampleTestResult
	| aTestResult |
	aTestResult := STestResult new.
	aTestResult addToPassed: (STbPersonTest selector: #testFirstnameAccessors).
	^ aTestResult.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 20:13:40.15'!
ensureCoverageOfExampleCode
	self runTbTests. ! !

!SDistributionTests methodsFor: 'running' stamp: 'bs 8/11/2010 14:16:39.4'!
setUp
	super setUp.
	self codeSight testReplicator: SReplicator basicNew.
	self codeSight testActorId: ActorIdMock new.
	self codeSight maintenanceReplicator: SReplicator basicNew.
	self codeSight maintenanceActorId: ActorIdMock new.! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:23:04.377'!
testNonInstrumentation
	| aSubclass aSelector |
	
	self runTbTests.
	self should: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self codeSight turnOffStandaloneMode.
	self shouldnt: [ (STbPerson >> #firstname) isMwMethodWrapper ].
	
	self undoInTearDownDo: [
		aSubclass := self createExamplePersonSubclass.
		aSelector := aSubclass compile: self exampleMethodSource ].
	
	self shouldnt: [ (aSubclass >> aSelector) isMwMethodWrapper ].! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 14:19:01.296'!
testOpenEvents
	self codeSight makeDistributed.
	self assert: self codeSight openEvents isEmpty.
	self compileExampleMethod.
	self deny: self codeSight openEvents isEmpty.
	self assert: (self codeSight openEvents next isKindOf: SMethodModified)! !

!SDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 16:32:27.674'!
testProcessingOfUpdates
	| aTestResult testsToCoverageData |
	self exampleMethod fixes: self exampleTestMethod.
	self codeSight makeDistributed.
	
	aTestResult := self createExampleTestResult.
	testsToCoverageData := self createExampleCoverageData.
	
	self csTestRunner reset.
	self compileExampleMethod.
	self should: [ self csTestRunner result passed isEmpty ].
	self shouldnt: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod hasFixedTestMethods ].
	
	self codeSight testResult: aTestResult.	
	self codeSight testResult: aTestResult testCoverage: testsToCoverageData.
	self shouldnt: [ self csTestRunner result passed isEmpty ]. 
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	
	self csTestRunner reset.
	self compileExampleMethod.
	self codeSight testResult: aTestResult.
	self codeSight testResult: aTestResult testCoverage: testsToCoverageData.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].! !

SCstTestCase subclass: #SEvolutionTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

SEvolutionTestCase subclass: #SFixedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 12/9/2009 16:57'!
charIntervalIn: codeString fromLine: from toLine: to
	| start end |
	self assert: [ codeString lineCount >= to and: [ codeString lineCount >= from ] ].
	start := 1.
	(1 to: (from - 1)) do: [:lineNo | 
		start := start + (codeString lineNumber: lineNo) size ].
	
	end := start.
	(to to: codeString lineCount) do: [:lineNo |
		end := end + (codeString lineNumber: lineNo) size ].
	
	^ (start to: end)! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:42:40.485'!
testRecompiling

	self runTbTests.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	(self exampleMethod) fixes: self exampleTestMethod.
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	self compileExampleMethod.
	self should: [ self exampleMethod hasCoveringTestMethods ]. 
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].! !

!SFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.27'!
testRefactoringVariations
	| code anExamplePerson variationWrapper selectionInterval |
	
	code := (STbPerson sourceCodeAt: #firstname) asString.
	selectionInterval := self charIntervalIn: code fromLine: 2 toLine: 2.
	self assert: [ code lineCount = 2 ].
	
	anExamplePerson := STbPerson new.
	anExamplePerson firstname: 'Paul'.
	self should: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper := SRefactoringVariationWrapper 
							on: #firstname 
							inClass: STbPerson 
							withCode: #firstname.
	
	variationWrapper installClosestToMethod.
	self deny: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper uninstall.! !

SCstTestCase subclass: #SFailedExpressionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.504'!
failingTestMethod
	^ STbPersonTest >> #testFailing! !

!SFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:50.496'!
testRecordingOfFailedExpression
	| source class selector |
	class := STbPersonTest. 
	source := 'testRecordingOfFailedExpression', String cr,  'self notExistingMethod'.
	self undoInTearDownDo: [
		selector := self installMethod: source inClass: STbPersonTest ].
	
	self assert: [ (class >> selector) failedExpressionInterval notNil ].
	self assert: [ (class >> selector) failedExpression = 'notExistingMethod' ].
	
	STbPersonTest compile: 'testRecordingOfFailedExpression', String cr.
	self assert: [ (class >> selector) failedExpressionInterval isNil ].! !

SCstTestCase subclass: #STddAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:32:16.839'!
createFooBarTestClass
	| aClass |
	aClass := TestCase subclass: #STbFooBarTest
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: self tbCategory.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass.! !

!STddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:34:45.551'!
createSubclassTestCode
	^ 'testFirstnameAccessorsForPersonAndAllSubclasses
			| aPerson aName |
			STbPerson withAllSubclassesDo: [:aPersonClass | 
			aPerson := aPersonClass new.
			aName := #Bastian asString.
			aPerson firstname: aName.
			self assert: aPerson firstname = aName. ]'! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/2/2011 23:00:35.032'!
testAddAndChangeOfNonTestMethodsInTestClasses
	| selector |
	[	selector := #setUp.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty].
		STbPersonTest compile: selector, String crlf.
		STbPersonTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty]]
	ensure: [
		(STbPersonTest includesSelector: selector) 
			ifTrue: [STbPersonTest removeSelector: selector]].
	! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/3/2011 13:18:19.672'!
testAdditionAndRemovalOfOverriddenMethod
	| methodSelector testMethodSelector methodSource personsubclass |
	
	methodSelector := #asString.
	methodSource := (STbPerson >> methodSelector) clientMethod getSource.

	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: methodSource.
		testMethodSelector := self installMethod: self createSuperCallTestCode inClass: STbPersonTest ].
	
	self runTestMethods: {STbPersonTest >> testMethodSelector}.
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	self undoInTearDownDo: [
		self removeMethod: (STbPerson >> methodSelector) ].
		
	self should: [ self csTestRunner result passed size = 1 ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	STbPerson compile: methodSource.
	self should: [ self csTestRunner result passed size = 1].
	self shouldnt: [ (STbPerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/3/2011 14:32:34.303'!
testAdditionAndRemovalOfSubclassesWithOverridingMethods
	| selector source subclass nStdPasses |
	nStdPasses := self tbNumberOfExpectedPasses.
	
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := STbPerson sourceCodeAt: selector.
	
	self undoInTearDownDo: [
		subclass := self createExamplePersonSubclass.
		self installMethod: self createSubclassTestCode inClass: STbPersonTest ].
	
	self runTbTests.
	self assert: nStdPasses + 1 equals: self csTestRunner result passed size.
	self assert: nStdPasses + 1 equals: (STbPerson >> #firstname) coveringTestMethods size.
	
	self csTestRunner reset.
	subclass compile: source.
	self assert: nStdPasses + 1 equals: self csTestRunner result passed size.
	
	self csTestRunner reset.
	subclass removeSelector: selector.
	self assert: 1 equals: self csTestRunner result passed size.
	
	subclass compile: source.
	self csTestRunner reset.
	subclass removeFromSystem.
	self assert: 1 equals: self csTestRunner result passed size.! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/11/2010 10:36:19.523'!
testDistinguishingOfTestsHavingEqualHashes
	| failingCode1 failingMethod1 failingCode2 failingMethod2 |
	
	failingCode1 := 'testFailingTest1 self fail'.
	failingCode2 := 'testFailingTest2 self fail'.
	"test adding"
	self undoInTearDownDo: [
		failingMethod1 := self installMethod: failingCode1 inClass: STbPersonTest].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].
	
	
	self undoInTearDownDo: [
		failingMethod2 := self installMethod: failingCode2 inClass: STbPersonTest].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].

	"test modification"
	self installMethod: failingCode1 inClass: STbPersonTest.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod1 ] ] ].

	self installMethod: failingCode2 inClass: STbPersonTest.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = failingMethod2 ] ] ].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 7/12/2010 20:27:50.607'!
testDontResetResultIfThereIsNothingToRun
	|source|
	self csTestRunner runSuite: STbPersonTest suite.
	self shouldnt: [self csTestRunner result passed = 0].
	
	source := ('fooBar', String crlf).
	self undoInTearDownDo: [
		self installMethod: source inClass: STbPerson.].
	self shouldnt: [self csTestRunner result passed = 0].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/3/2011 14:32:33.055'!
testExecutionOfAddedTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 8/10/2010 20:15:29.16'!
testExecutionOfCoveringTestsAfterMethodChanged

	self tracePackage: self tbPackage.
	self runTbTests. 
	
	STbPerson compile: (STbPerson sourceCodeAt: #firstname:).
	self should: [self csTestRunner result passed isEmpty not]. 
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/3/2011 14:32:34.289'!
testExecutionOfFailedTestsAfterMethodAddedOrChanged
	| methodSelector appMethodSource method | 
	methodSelector := #firstname.
	appMethodSource := STbPerson sourceCodeAt: methodSelector.
	method := STbPerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		self removeMethod: method].
	
	self runTbTests.
	self deny: [self csTestRunner result errors isEmpty].
	self should: [self csTestRunner result errors anySatisfy: [:test | 
		(test isKindOf: STbPersonTest) and: [test selector = #testFirstnameAccessors]]].
	
	STbPerson compile: appMethodSource.
	self should: [self csTestRunner result errors isEmpty].
	self deny: [self csTestRunner result passed isEmpty].
	self should: [self csTestRunner result passed first isKindOf: STbPersonTest].! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/11/2010 07:41'!
testForEndlessLoopUsingDoForEachCoveredMethod

	"self csTestRunner testCasesToRun add: (CSExampleTest selector: #testFirstnameAccessors).
	self csTestRunner runOpenTestCasesInSuite."
	
	"original version that break a lot of stuff.
	 I assume that using 'self doForEachCoveredMethod' in another doForEach.. Block was not a good idea"
	"CSTestRunner >> #runOpenTestCasesInSuite
	| aSuite testMethod |
	
	aSuite := TestSuite new.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}] ].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	self doForEachCoveredMethod: nil."
	! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 3/3/2011 14:32:34.277'!
testModificationOfClass
	self tracePackage: self tbPackage.
	self runTbTests.
	
	self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
	
	self addInstVar: 'foobar' to: STbPerson.
	self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
	self addClassVar: 'Foobar' to: STbPerson.
	self should: [(STbPerson >> #firstname) hasCoveringTestMethods]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 3/3/2011 14:32:34.297'!
testModificationTestOfClass
	self addInstVar: 'foobar' to: STbPersonTest.
	self assert: STbPersonTest testMethods size equals: self csTestRunner result tests size.
	self should: [(STbPerson >> #firstname) hasCoveringTestMethods]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:10'!
testRemovalOfFailedTestCase
	| selector testClass |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	selector := #testFooBar.
	self installMethod:  selector, String crlf, String tab, 'self fail.' inClass: testClass.
	
	self should: [self csTestRunner result failures notEmpty].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: testClass) and: [test selector = selector]]].
	
	testClass removeSelector: selector.
	self should: [self csTestRunner result failures isEmpty].
	self should: [self csTestRunner result errors isEmpty]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 4/23/2010 09:19:00.846'!
testRemovalOfFailedTestsAfterTestClassOrMethodRemoved
	| testClass fooBarSource testMethodSelector |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	fooBarSource := 'testFooBar', String crlf , String tab , 'self fail'.
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeSelector: testMethodSelector.
	self should: [ self csTestRunner result failures isEmpty ].
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeFromSystem.
	self should: [ self csTestRunner result failures isEmpty ].! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/8/2010 17:31'!
testRemovalOfTestClass
	|testClass testClassName|
	[	testClass := self createFooBarTestClass. 
		testClassName := testClass name.
		testClass compile: 'testFooBar', String crlf, String tab, 'self fail'.
		self should: [self csTestRunner result failures size = 1].
		testClass removeFromSystem.
		self should: [self csTestRunner result failures isEmpty]]
	ensure: [
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [testClass removeFromSystem]]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 3/3/2011 14:32:34.283'!
testRenamingOfClass
	|class oldName|
	[
		self runTbTests.
		self should: [(STbPerson >> #firstname) hasCoveringTestMethods].
		
		class := STbPerson.
		oldName := class name.
		STbPerson rename: (oldName, 'new').
		self should: [(class >> #firstname) hasCoveringTestMethods].]
	ensure: [
		class rename: oldName.
		self instrumentor uninstrumentClass: STbPerson]! !

!STddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/3/2011 14:32:33.064'!
testRepro
	| aSuite |
	STbPerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	
	aSuite := TestSuite new.
	aSuite addTest: (STbPersonTest selector: #testFirstnameAccessors).
	self csTestRunner runSuite: aSuite.
	self should: [ self csTestRunner result passed size = 1 ]! !

!STddAutoRunTests methodsFor: 'test class events' stamp: 'bs 8/11/2010 10:23:28.129'!
testRunningOnlyModifiedTestMethod
	self runTbTests.
	self compileExampleTestMethod.
	self assert: 1 equals: self csTestRunner result tests size.! !

STddAutoRunTests subclass: #STestModificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Tests'!

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:33.047'!
testAddingTestMethod
	| source runTestCase aMethod |
	aMethod := STbPersonTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	STbPersonTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: STbPersonTest].
	self should: [runTestCase selector = aMethod selector].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2011 23:00:13.805'!
testModifyingTestMethod
	| exampleTestMethodVersion1 coveringTestMethods |
	self should: [self csTestRunner result passed isEmpty].
	
	self compileExampleTestMethod.
	self shouldnt: [self csTestRunner result passed isEmpty].
	
	exampleTestMethodVersion1 := self exampleTestMethod.
	self compileExampleTestMethod.
	coveringTestMethods := self exampleMethod coveringTestMethods.
	self should: [coveringTestMethods includes: self exampleTestMethod].
	self shouldnt: [coveringTestMethods includes: exampleTestMethodVersion1].! !

!STestModificationTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2011 23:00:19.159'!
testRemovingTestClassOrMethod
	| testClass testMethodSelector |
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	self undoInTearDownDo: [ testClass := self createFooBarTestClass ].
	testMethodSelector := testClass compile: self exampleTestMethodSource.
	
	self should: [self csTestRunner result passed size = 1].
	self should: [self exampleMethod coveringTestMethods size = 1].
	
	testClass removeSelector: testMethodSelector.
	self should: [self exampleMethod coveringTestMethods size = 0].
	
	testClass compile: self exampleTestMethodSource.
	testClass removeFromSystem.
	
	self should: [self exampleMethod coveringTestMethods size = 0].
	! !

Object subclass: #ATddBenchmarker
	instanceVariableNames: 'packages methods coveredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 03:51'!
appMethods

	| class |
	^ self methods reject: [:ea |
		class := ea methodClass ifNil: [ea clientMethod searchForClass].
		class
			ifNil: [false]
			ifNotNil: [class inheritsFrom: TestCase]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/20/2009 03:38'!
classesOfPackages

	^ (packages gather: [:p | p classes]) asSet! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestClassesTimesPerMethodFrom: timeForEachTestClass

	| testClassesTimesPerMethod |
	testClassesTimesPerMethod := Dictionary new. "appMethod -> coveringTestClassesTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testClassesTimesPerMethod
			at: appMethod
			put: (self coveringTestClassesTimeFor: appMethod from: timeForEachTestClass)].
	^ testClassesTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestTimesPerMethodFrom: timeForEachTest

	| testTimesPerMethod |
	testTimesPerMethod := Dictionary new. "appMethod -> coveringTestMethodsTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testTimesPerMethod
			at: appMethod
			put: (self coveringTestMethodsTimeFor: appMethod from: timeForEachTest)].
	^ testTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 03:48'!
computeTimeForAllTestsFrom: timeForEachTest

	^ timeForEachTest values sum.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'bs 7/20/2010 22:54:27.825'!
computeTimeForEachTest

	| aTestRunner testClasses timeForEach |
	aTestRunner := SCoverageTestRunner new.
	testClasses := self testClassesOfPackages.
	timeForEach := Dictionary new.
	testClasses
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | | time |
					time := [aTestRunner runSuite: (testClass suiteWithSelectorsMatching: s)] timeToRun.
					timeForEach at: (testClass >> s) methodReference put: time]]
		displayingProgress: 'Running Tests (' , testClasses size asString, ' test classes)'.
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:11'!
computeTimeForEachTestClassFrom: timeForEachTest

	| timeForEach |
	timeForEach := Dictionary new.
	self testClassesOfPackages do: [:class | | methodsOfClass time |
		methodsOfClass := timeForEachTest keys select: [:m | m actualClass = class].
		time := methodsOfClass inject: 0 into: [:t :m | (timeForEachTest at: m) + t].
		timeForEach at: class put: time].
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestClassesTimeFor: appMethod from: timeForEachTestClass

	| testClasses |
	testClasses := (appMethod coveringTestMethods
		collect: [:ea | ea methodClass]
		thenSelect: [:ea | ea isObsolete not]) asSet.
	^ testClasses
		inject: 0
		into: [:sum :c | (timeForEachTestClass at: c) + sum].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestMethodsTimeFor: appMethod from: timeForEachTest

	^ appMethod coveringTestMethods
		inject: 0
		into: [:sum :m | (timeForEachTest at: m methodReference ifAbsent: [0"???"]) + sum].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/20/2009 18:17'!
measureCoveringTimesForPackages: packageString

	^ String streamContents: [:stream |
		self 
			measureCoveringTimesForPackages: packageString 
			printOn: stream].
	! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/4/2010 12:47:14.296'!
measureCoveringTimesForPackages: packageString printOn: stream

	"^ #(coveringTestMethodsTime coveringTestClassesTime timeForRunningAllTestsAtEveryChange)"
	| timeForEachTest timeForEachTestClass timeForAllTests testClassesTimesPerMethod testTimesPerMethod coveredTestMethodsTimes coveredTestClassesTimes |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	packages do: [:p | SWrappingInstrumentor systemInstrumentor instrumentPackage: p].

	timeForEachTest := self computeTimeForEachTest.
	timeForEachTestClass := self computeTimeForEachTestClassFrom: timeForEachTest.
	timeForAllTests := self computeTimeForAllTestsFrom: timeForEachTest.
	testTimesPerMethod := self computeTestTimesPerMethodFrom: timeForEachTest.
	testClassesTimesPerMethod := self computeTestClassesTimesPerMethodFrom: timeForEachTestClass.

	"CSV style output
	appMethods,coveredMethods,coveredTestMethodsTimes average, coveredTestMethodsTimes median, coveredTestMethodsTimes min, coveredTestMethodsTimes max, coveredTestMethodsTimes sum, coveredTestClassesTimes avg, coveredTestClassesTimes median, coveredTestClassesTimes sum, timeForAllTests, timeForAllTests sum"
	coveredTestMethodsTimes := testTimesPerMethod values.
	coveredTestClassesTimes := testClassesTimesPerMethod values.
	stream
		print: self appMethods size; nextPut: $,;
		print: (self methodsCovered: self appMethods) size; nextPut: $,;
		print: (coveredTestMethodsTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestMethodsTimes median roundTo: 1); nextPut: $,;
		print: coveredTestMethodsTimes min; nextPut: $,;
		print: coveredTestMethodsTimes max; nextPut: $,;
		print: coveredTestMethodsTimes sum; nextPut: $,;
		print: (coveredTestClassesTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestClassesTimes median roundTo: 1); nextPut: $,;
		print: coveredTestClassesTimes sum; nextPut: $,;
		print: timeForAllTests; nextPut: $,;
		print: (self methodsCovered: self methods) size * timeForAllTests;
		cr.
		
	packages do: [:p |SInstrumentor systemInstrumentor uninstrumentPackage: p].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 7/20/2010 22:54:27.862'!
measureTestExecutionTimeForPackages: packageString

	| aTestSuite testClasses nRuns |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	"packages do: [:p | CSCoverageTracingWrapper registerPackage: p]."
	
	aTestSuite := TestSuite new.
	testClasses := self testClassesOfPackages.
	
	self testClassesOfPackages
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | aTestSuite addTest: (testClass selector: s)]].
			
	nRuns := 2.
	^ ([nRuns timesRepeat: [SCoverageTestRunner new runSuite: aTestSuite]] timeToRun / nRuns).
	! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
methods

	^ methods ifNil: [
		methods := self classesOfPackages gather: [:class |
			class methodDict values]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 04:16'!
methodsCovered: methodCol

	^ methodCol select: [:ea | ea hasCoveringTestMethods].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
testClassesOfPackages

	^ self classesOfPackages select: [:class |
		class inheritsFrom: TestCase].! !

Object subclass: #ATddMCAnalyzer
	instanceVariableNames: 'inspector methodVersionResult doAfterGathering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'bs 11/20/2009 15:42'!
printVersionDatesOfPackage: packageName

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: packageName
		thenDo: [:versionInfos |
			self halt.
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'rkrk 9/20/2009 00:57'!
printVersionDatesOfPackage: packageName inRepo: repo

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: {packageName}
		in: repo
		thenDo: [:versionInfos |
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.794'!
gatherVersionsOf: packageNames in: mcRepository thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld 
		newForPackagesNamed: packageNames
		inRepo: mcRepository.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.787'!
gatherVersionsOf: packageName thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:26.779'!
inspect: selector of: class in: packageName 
	inspector ifNotNil: [ inspector stop ].
	inspector := SMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector 
		startInspectVersionsFor: selector
		in: class.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'nil' stamp: 'rkrk 9/20/2009 00:58'!
methodVersionResult

	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:24'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifFalse: [^ self].
	Transcript cr show: 'done'.
	doAfterGathering value: methodVersionResult.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:13'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #versionFound ifFalse: [^self].
	Transcript cr; show: 'Found ' , anObject asString.
	methodVersionResult add: anObject.! !

Object subclass: #ATddReceiverAnalyzer
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
getClassOf: method

	^ method methodClass ifNil: [method searchForClass].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:38'!
init

	stream := WriteStream on: ''.! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:29'!
isOverwritten: method

	"CompiledMethod>>overridingMethods does not work"
	^ (self overridingClasses: method) notEmpty! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:35'!
methodsNotOverwrittenIn: package

	^ ((package coreMethods collect: [:ea | ea compiledMethod]
		thenSelect: [:method | method hasCoveringTestMethods])
		reject: [:method | self isOverwritten: method])
		reject: [:method | (self getClassOf: method) allSubclasses isEmpty].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
overridingClasses: method

	^ (self getClassOf: method) allSubclasses select: [:ea |
		ea includesSelector: method selector].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 22:29'!
printTestsForOverwrittenMethodsWithAndWithoutReceiverIn: package

	"self printTestsForOverwrittenMethodsWithAndWithoutReceiverIn:
		(PackageInfo named: 'AweSOM')"
	| methods
	appMethodClass pureTestCount testCountReceiver allNoRecv allRecv stat |
	self init.
	methods := self methodsNotOverwrittenIn: package.
	methods do: [:appMethod |
		appMethodClass := self getClassOf: appMethod.
		pureTestCount := appMethod coveringTestMethods size.
		allNoRecv := allRecv := 0.
		"<for each subclass>"
		appMethodClass allSubclasses do: [:subclass |
			testCountReceiver := 0.
			"<for each coveringTest>"
			"<if subclass or any of its subclasses are
			included in receiverclasses of coveringTest --> count+1>"
			testCountReceiver := appMethod coveringTestMethods count: [:test | 
				stat := test statisticsForCoveredMethod: appMethod clientMethod.
				(stat receiverClasses includesAnyOf: subclass withAllSubclasses)].
			"----"
			allNoRecv := allNoRecv + pureTestCount.
			allRecv := allRecv + testCountReceiver.
			"print it"
			stream
				cr; nextPutAll: 'If method '; nextPutAll: appMethod selector;
				nextPutAll: ' would be added to '; nextPutAll: subclass name; space;
				print: pureTestCount; nextPutAll: '/'; print: testCountReceiver;
				nextPutAll: ' should run.'.
		].
		"print it again"
		stream
			cr; print: allRecv; nextPut: $/; print: allNoRecv;
			nextPut: $=;
			print: (allRecv isZero
				ifTrue: [0]
				ifFalse: [allRecv / allNoRecv * 100 asFloat]).
		Transcript show: stream contents.
	].! !

Object subclass: #ATddVersionLoader
	instanceVariableNames: 'repo versionFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!ATddVersionLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
loadVersionsNamed: versionNames from: mcRepository

	| fileNames |
	fileNames := versionNames collect: [:ea |
		(ea endsWith: '.mcz') ifTrue: [ea] ifFalse: [ea , '.mcz']].
	self new
		repo: mcRepository;
		versionFileNames: fileNames;
		loadAll;
		yourself.! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:46'!
loadAll

	| versions |
	versions := self versionFileNames collect: [:ea |
		repo loadVersionFromFileNamed: ea].
	versions do: [:ea | ea load].! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
repo: mcRepository

	repo := mcRepository! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:44'!
versionFileNames

	^ versionFileNames! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:43'!
versionFileNames: fileNames

	versionFileNames := fileNames! !

Object subclass: #CodeSightSarBuilder
	instanceVariableNames: 'zip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Install'!

!CodeSightSarBuilder commentStamp: 'mt 2/23/2011 09:58:57.768' prior: 0!
!!!!!! DEPRECATED !!!!!!

Creates a SAR-Installer for CodeSight. Should not be used anymore. Use Metacello configuration instead.!

!CodeSightSarBuilder class methodsFor: 'service' stamp: 'rkrk 11/27/2009 15:14'!
create

	"self create"
	^ self new create! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'bs 1/25/2010 10:19:49.792'!
addFiles

	| paths |
	paths := {self downloadLatestSwaUtilVersion.
	self downloadMethodWrapperMczs.
	self downloadLatestCodeSightVersion.
	self	downloadLatestCodeSightTestExamplesVersion} gather: [:ea |
		(ea isCollection and: [ea isString not]) ifTrue: [ea] ifFalse: [{ea}]]. "flatten"
	paths do: [:path | 
		zip addFile: path as: (path subStrings: '/\') last].! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 13:28'!
addPostScript

	zip addString: self postscript as: 'install/postscript'.! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 13:28'!
addPreamble

	zip addString: self preamble as: 'install/preamble'.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:12'!
create

	self
		createZip;
		addPreamble;
		addPostScript;
		addFiles;
		writeAndCloseZip.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 13:30'!
createZip

	zip := ZipArchive new.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightTestExamplesVersion

	^ self fromCodeSightRepoDownload: 'CodeSightTestExamples-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightVersion

	^ self fromCodeSightRepoDownload: 'CodeSight-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:57.281'!
downloadLatestSwaUtilVersion

	^ self fromSwaUtilitiesRepoDownload: 'SwaUtil-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:45'!
downloadMethodWrapperFromSqueakMap

	| squeakMap package |
	squeakMap := SMSqueakMap default.
	squeakMap objects ifNil: [
		squeakMap inspect.
		self error: 'There is a problem with the SqueakMap instance, inst var objects should be a dictionary but is nil. Please fix it and restart the build process!!'].
	package := squeakMap packageWithNameBeginning: 'MethodWrappers'.
	^ (SMInstaller forPackageRelease: package lastRelease)
		download;
		fullFileName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:59'!
downloadMethodWrapperMcz

	^ self fromCodeSightRepoDownload: 'MethodWrappers'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:30'!
downloadMethodWrapperMczs

	^ {self fromCodeSightRepoDownload: 'MethodWrappers-'. "newest"
	self fromCodeSightRepoDownload: 'Methodwrappers-rkrk.1'. "for non trunk images"}
	! !

!CodeSightSarBuilder methodsFor: 'default' stamp: 'rkrk 11/27/2009 15:14'!
filename

	^ 'CodeSight-' , Date today yyyymmdd , '.sar'! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromCodeSightRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/CodeSight'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromRepo: repoUrl download: packageOrVersionName

	| repo versionName filename mimeDoc |
	repo := MCHttpRepository
		location: repoUrl
		user: ''
		password: ''.
	versionName := repo allVersionNames detect: [:ea | ea startsWith: packageOrVersionName]. "assume latest first. Seems to work..."
	filename := versionName , '.mcz'.
	mimeDoc := (Url absoluteFromText:  (repo urlForFileNamed: filename)) retrieveContents.
	^ FileStream
		forceNewFileNamed: filename
		do: [:s | s binary. s nextPutAll: mimeDoc content. s fullName].! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:23.85'!
fromSwaUtilitiesRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 15:10'!
postscript

	^ 'CSCoverageTracingWrapper initialize'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:59.759'!
preamble

	^ String streamContents: [:s |
		s
			nextPutAll: self preambleSwaUtilInstall; cr;
			nextPutAll: self preambleMethodWrapperInstall; cr;
			nextPutAll: self preambleCodeSightInstall; cr;
			nextPutAll: self preambleCodeSightTestExamplesInstall; cr].! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 15:04'!
preambleCodeSightInstall

	^ '(self membersMatching: ''CodeSight-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:17'!
preambleCodeSightTestExamplesInstall

	^ '(self membersMatching: ''CodeSightTestExamples-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:45'!
preambleMethodWrapperInstall

	^ '"For trunk image choose newest version, for olde images choose 1.mcz"
	SystemVersion current highestUpdate <= 7179
		ifTrue: [self installMember: (self memberNamed: ''Methodwrappers-rkrk.1.mcz'')]
		ifFalse: [(self membersMatching: ''MethodWrappers-*.mcz'') do: [:ea |
					ea fileName ~= ''Methodwrappers-rkrk.1.mcz'' ifTrue: [
						self installMember: ea]]].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 03:01'!
preambleSWAUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:24.481'!
preambleSwaUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:15'!
writeAndCloseZip

	zip
		writeToFileNamed: self filename;
		close.! !

Object subclass: #DummyMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!DummyMonitor methodsFor: 'as yet unclassified' stamp: 'bs 1/16/2010 11:10'!
critical: aBlock
	^ aBlock value! !

Object subclass: #SAbstractInfo
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SAbstractInfo commentStamp: 'mt 2/23/2011 10:11:24.328' prior: 0!
Singleton-like access point to find the current codeSight instance as well as some convenience messages.

Can always be used because a null-object is created if CodeSight is disabled or not active.

!!!!!! As CodeSight instruments methods, there should only be once instance at a time. This info class structure satisfies that constraint.!

!SAbstractInfo class methodsFor: 'system instance' stamp: 'mt 2/23/2011 10:06:44.378'!
instance
	"Instance := nil"
	^ Instance ifNil: [ Instance := SNullInfo new ]! !

!SAbstractInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 13:50'!
instance: anInfoObject
	Instance dependents do:  [ :ea | anInfoObject addDependent: ea ].
	Instance breakDependents.
	Instance := anInfoObject.
	Instance changed: #newTestResult.
	! !

!SAbstractInfo class methodsFor: 'tracing' stamp: 'mt 2/23/2011 10:04:12.931'!
mayClassMethodBeInstrumented: selector

	^ selector ~= #instance! !

!SAbstractInfo class methodsFor: 'system instance' stamp: 'mt 2/23/2011 10:12:09.704'!
reset

	self instance: SNullInfo new.! !

!SAbstractInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 12:57'!
isActive
	self subclassResponsibility! !

!SAbstractInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	self subclassResponsibility! !

!SAbstractInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 12:56'!
isRunning
	self subclassResponsibility! !

!SAbstractInfo methodsFor: 'actions' stamp: 'bs 1/14/2010 12:56'!
openTestRunner
	self subclassResponsibility! !

!SAbstractInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:56'!
testResult
	self subclassResponsibility! !

SAbstractInfo subclass: #SNullInfo
	instanceVariableNames: 'emptyTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SNullInfo commentStamp: 'mt 2/23/2011 10:10:08.479' prior: 0!
Null-object for codeSight information.!

!SNullInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 12:57'!
isActive
	^ false! !

!SNullInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	^ false! !

!SNullInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 12:57'!
isRunning
	^ false! !

!SNullInfo methodsFor: 'actions' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self shouldNotImplement.! !

!SNullInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:55'!
testResult
	^ emptyTestResult ifNil: [ emptyTestResult := TestResult new ] ! !

SAbstractInfo subclass: #SRealInfo
	instanceVariableNames: 'codeSight isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SRealInfo commentStamp: 'mt 2/23/2011 10:10:30.202' prior: 0!
Real codeSight information. Accesses the currently active codeSight instance.!

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
codeSight
	^ codeSight! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:37'!
codeSight: anObject
	codeSight := anObject.! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
csTestRunner
	^ self codeSight csTestRunner! !

!SRealInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 12:50'!
isActive
	^ true! !

!SRealInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 14:47'!
isClassManaged: aClass
	^ self codeSight isClassManaged: aClass! !

!SRealInfo methodsFor: 'testing' stamp: 'bs 1/14/2010 13:03'!
isRunning
	^ isRunning ifNil: [ isRunning := false ]! !

!SRealInfo methodsFor: 'actions' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self codeSight openTestRunner! !

!SRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:42'!
testResult
	^ self csTestRunner result! !

!SRealInfo methodsFor: 'updating' stamp: 'bs 2/25/2010 12:56:32.951'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun) includes: aSymbol) ifFalse: [^ self].
	aSymbol = #startTestRun ifTrue: [isRunning := true].
	aSymbol = #endTestRun ifTrue: [isRunning := false].
	self changed: aSymbol.! !

Object subclass: #SCodeSight
	instanceVariableNames: 'eventProcessors managedPackages instrumentor testRunner fixedMaintainer isSystemInstance systemEventAnalyzer testActorId developmentActorId maintenanceActorId testReplicator maintenanceReplicator openEvents actor operationMode'
	classVariableNames: 'Instance Instances SourceCodeMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SCodeSight commentStamp: 'mt 2/15/2011 18:02:12.12' prior: 0!
Available object events:

#operationModeToggled ... triggered when switching between standalone and distribution mode
#systemInstanceToggled ... triggered when installing or removing this instance at system-level!

!SCodeSight class methodsFor: 'synchronizing' stamp: 'bs 1/25/2010 18:55:14.46'!
sourceCodeMonitor
	" SourceCodeMonitor := nil"
	^ SourceCodeMonitor ifNil: [ SourceCodeMonitor := DummyMonitor new ]! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 7/4/2010 12:48:08.022'!
actor
	actor ifNil: [ 
		actor := SActor new.
		actor codeSight: self ].
	^ actor! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 3/2/2011 21:46:27.915'!
addToManagedPackages: aPackageInfo
	self managedPackages add: aPackageInfo.
	self instrumentor instrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'mt 2/23/2011 09:36:49.313'!
cleanUp

	self managedPackages do: [:ea | self removeFromManagedPackages: ea].
	self isSystemInstance ifTrue: [ self uninstallFromSystem ].
	self systemNotifier noMoreNotificationsFor: self.
	self csTestRunner cleanUp.
	self instrumentor cleanUp.! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 22:46:48.241'!
createExtensionBlock
	^ self csTestRunner createExtensionBlock! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'mt 2/23/2011 17:50:22.158'!
createWeavingInstrumentor

	^ SWeavingInstrumentor new
		createExtensionBlock: self createExtensionBlock! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'mt 2/23/2011 17:48:05.188'!
createWrappingInstrumentor

	^ SWrappingInstrumentor new
		createExtensionBlock: self createExtensionBlock! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ testRunner! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner: anObject
	testRunner := anObject! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 2/23/2010 08:53:31.317'!
developmentActorId
	^ developmentActorId 
		ifNil: [ developmentActorId := ActorId localhostPort: self developmentActorPort ]! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 2/23/2010 08:49:48.69'!
developmentActorPort
	^ 12000! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:04:24.505'!
eventProcessors
	^ eventProcessors ifNil: [eventProcessors := OrderedCollection new]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 8/10/2010 17:16:29.376'!
fixedMaintainer
	^ fixedMaintainer! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 8/10/2010 17:16:29.382'!
fixedMaintainer: anObject
	fixedMaintainer := anObject! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 3/2/2011 15:24:46.773'!
handle: aSystemEvent affectedClass: aClass
	| sightEvent testMethodNames |
	(self isClassManaged: aClass)
		ifTrue: [ 
			sightEvent := self systemEventAnalyzer analyze: aSystemEvent.
			self preprocess: sightEvent.
			self runsDistributed
				ifFalse: [
					self process: sightEvent.
					self postprocess: sightEvent]
				ifTrue: [
					self openEvents nextPut: sightEvent.
					testMethodNames := sightEvent testsToRun collect: [:ea | ea qualifiedName].
					self testActorId runTests: testMethodNames.
					self maintenanceActorId maintainCoverage: testMethodNames]]! !

!SCodeSight methodsFor: 'event processing' stamp: 'mt 2/21/2011 10:07:52.558'!
handleSystemEvent: anEvent
	self runsDistributed ifTrue: [ self replicateModification: anEvent ].
	
	(#(class method) includes: anEvent itemKind)
		ifTrue: [self handle: anEvent affectedClass: anEvent itemClass].! !

!SCodeSight methodsFor: 'initialize-release' stamp: 'mt 2/21/2011 10:23:08.103'!
initialize

	super initialize.

	self csTestRunner: SCoverageTestRunner new.
	self csTestRunner addDependent: self.
	self fixedMaintainer: SFixedMaintainer new.
	
	self instrumentor: self createWrappingInstrumentor.
	self eventProcessors add: self instrumentor.
	
	#(class method protocol category) do: [ :itemKind |
		self systemNotifier notify: self ofSystemChangesOfItem: itemKind  using: #handleSystemEvent: ].! !

!SCodeSight methodsFor: 'system installation' stamp: 'mt 2/23/2011 10:08:21.98'!
installIntoSystem

	SAbstractInfo instance: (SRealInfo new codeSight: self; yourself).
	self csTestRunner addDependent: SAbstractInfo instance.
	self isSystemInstance: true.! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:42.226'!
instrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor instrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor
	^ instrumentor! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor: anObject
	instrumentor := anObject! !

!SCodeSight methodsFor: 'package management' stamp: 'mt 2/23/2011 16:54:44.232'!
isClassManaged: aClass
	^ self managedPackages includes: (SInstrumentor packageOfClass: aClass)! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:40'!
isSystemInstance
	^ isSystemInstance ifNil: [ isSystemInstance := false ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'mt 2/15/2011 17:53:48.692'!
isSystemInstance: aBoolean

	aBoolean = isSystemInstance ifTrue: [^ self].

	isSystemInstance := aBoolean.
	
	self changed: #systemInstanceToggled. ! !

!SCodeSight methodsFor: 'distribution - messages' stamp: 'mt 3/2/2011 16:57:48.024'!
maintainCoverage: testMethodNames
	| testMethodsToRun testsToCoverageData coverageData |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner runAndTraceTestMethods: testMethodsToRun.
	
	testsToCoverageData := Dictionary new.
	testMethodsToRun do: [ :testMethod | 
		coverageData := testsToCoverageData 
				at: testMethod qualifiedName
				put: Dictionary new.
		
		testMethod coveredMethodsStatistics keysAndValuesDo: [ :method :stats |
			coverageData 
				at: (method qualifiedName)
				put: (stats receiverClasses collect: [:ea | ea name ]) ] ].
		
	self developmentActorId 
		testResult: self csTestRunner result;
		testCoverage: testsToCoverageData.! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 8/11/2010 15:22:10.79'!
maintenanceActorId
	^ maintenanceActorId! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 8/11/2010 14:06:35.439'!
maintenanceActorId: anActorId
	maintenanceActorId := anActorId! !

!SCodeSight methodsFor: 'distribution-actors' stamp: 'bs 3/2/2011 15:25:09.774'!
maintenanceActorPort
	^ 12004! !

!SCodeSight methodsFor: 'distribution - accessing - replicas' stamp: 'bs 2/23/2010 13:29:23.295'!
maintenanceReplicator
	^ maintenanceReplicator! !

!SCodeSight methodsFor: 'distribution - accessing - replicas' stamp: 'bs 2/23/2010 13:29:33.135'!
maintenanceReplicator: anObject
	maintenanceReplicator := anObject! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'mt 2/15/2011 18:11:39.108'!
makeDistributed

	self operationMode: #distributed.! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'mt 2/15/2011 18:11:22.001'!
makeStandalone

	self operationMode: #standalone.! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 09:50:03.578'!
managedPackages
	^ managedPackages ifNil: [ managedPackages := WeakSet new ]! !

!SCodeSight methodsFor: 'distribution - messages' stamp: 'bs 3/2/2010 21:13:53.811'!
modification: aCommandString
	Compiler evaluate: aCommandString! !

!SCodeSight methodsFor: 'distribution - accessing' stamp: 'replica 2/24/2010 17:46:37.084'!
openEvents
	^ openEvents ifNil: [ openEvents := SharedQueue2 new ]! !

!SCodeSight methodsFor: 'distribution - accessing' stamp: 'mt 2/15/2011 18:10:38.043'!
operationMode

	^ operationMode ifNil: [operationMode := #standalone]! !

!SCodeSight methodsFor: 'distribution - accessing' stamp: 'mt 2/15/2011 18:11:45.346'!
operationMode: aSymbol
	"#distributed, #standalone"
	
	operationMode := aSymbol.! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/17/2010 19:23:24.053'!
postprocess: aSightEvent
	self eventProcessors reversed do: [:ea | ea postprocess: aSightEvent]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 16:09:29.106'!
preprocess: aSightEvent
	self eventProcessors do: [:ea | ea preprocess: aSightEvent]! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/11/2010 13:27:51.985'!
process: aSightEvent
	self eventProcessors do: [:ea | ea process: aSightEvent]! !

!SCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 11:49:00.632'!
removeFromManagedPackages: aPackageInfo
	self managedPackages remove: aPackageInfo.
	^ self instrumentor uninstrumentPackage: aPackageInfo.! !

!SCodeSight methodsFor: 'distribution - event processing' stamp: 'bs 2/25/2010 10:58:56.703'!
replicateModification: aSystemEvent
	| command |
	command := self testReplicator handle: aSystemEvent.
	{ self testActorId. self maintenanceActorId } do: [ :actorId | 
		actorId modification: command ].! !

!SCodeSight methodsFor: 'distribution - messages' stamp: 'bs 8/10/2010 18:26:03.291'!
runTests: testMethodNames
	| testMethodsToRun |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner runAndTraceTestMethods: testMethodsToRun.
	self developmentActorId testResult: self csTestRunner result copy.! !

!SCodeSight methodsFor: 'distribution - accessing' stamp: 'bs 2/23/2010 13:54:13.983'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!SCodeSight methodsFor: 'distribution - modes - testing' stamp: 'mt 2/15/2011 18:10:38.143'!
runsDistributed

	^ self operationMode = #distributed! !

!SCodeSight methodsFor: 'distribution - modes - testing' stamp: 'mt 2/15/2011 18:10:38.207'!
runsStandalone

	^ self operationMode = #standalone! !

!SCodeSight methodsFor: 'distribution - actors' stamp: 'bs 2/25/2010 08:39:15.208'!
startActorOnPort: anInteger

	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution - actors' stamp: 'bs 2/25/2010 08:39:10.874'!
startDevelopmentActor
	self startActorOnPort: self developmentActorPort! !

!SCodeSight methodsFor: 'distribution - actors' stamp: 'mt 2/14/2011 14:03:22.861'!
startMaintenanceActor
	self startReplicaActorOnPort: self maintenanceActorPort.
	self csTestRunner isInTddAutoRunMode: false.
	"self switchToWeavingInstrumentor."! !

!SCodeSight methodsFor: 'distribution - actors' stamp: 'bs 2/25/2010 08:38:55.908'!
startReplicaActorOnPort: anInteger
	
	Utilities setAuthorInitials: 'replica'.
	self actor startOn: anInteger.! !

!SCodeSight methodsFor: 'distribution - actors' stamp: 'bs 8/11/2010 15:04:22.282'!
startTestActor
	self startReplicaActorOnPort: self testActorPort.
	self eventProcessors removeAll.! !

!SCodeSight methodsFor: 'distribution - modes' stamp: 'mt 2/23/2011 09:14:54.855'!
switchToDistributedMode

	self
		turnOffStandaloneMode;
		turnOnDistributedMode.! !

!SCodeSight methodsFor: 'distribution - modes' stamp: 'mt 2/23/2011 09:14:51.528'!
switchToStandaloneMode

	self 
		turnOffDistributedMode;
		turnOnStandaloneMode.! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 7/1/2010 10:18:31.561'!
switchToWeavingInstrumentor
	self uninstrumentCode.
	self instrumentor: self createWeavingInstrumentor.
	self instrumentCode.! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:42.907'!
systemEventAnalyzer
	^ systemEventAnalyzer ifNil: [ systemEventAnalyzer := SSystemEventAnalyzer new ]! !

!SCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:47'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!SCodeSight methodsFor: 'event processing' stamp: 'mt 2/21/2011 10:52:12.196'!
tddAutoModeDisabled
	self eventProcessors
		remove: self fixedMaintainer ifAbsent: [];
		remove: self csTestRunner ifAbsent: []! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:18:50.497'!
tddAutoModeEnabled
	self eventProcessors 
		add: self csTestRunner;
		add: self fixedMaintainer! !

!SCodeSight methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:02:11.161'!
tddAutoModeToggled
	self csTestRunner isInTddAutoRunMode
		ifTrue: [self tddAutoModeEnabled]
		ifFalse: [self tddAutoModeDisabled]! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 8/11/2010 15:22:01.076'!
testActorId
	^ testActorId! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 8/11/2010 14:06:41.78'!
testActorId: anActorId
	testActorId := anActorId! !

!SCodeSight methodsFor: 'distribution - accessing - actors' stamp: 'bs 2/23/2010 08:49:39.406'!
testActorPort
	^ 12003! !

!SCodeSight methodsFor: 'distribution - accessing - replicas' stamp: 'bs 2/23/2010 13:29:47.025'!
testReplicator
	^ testReplicator! !

!SCodeSight methodsFor: 'distribution - accessing - replicas' stamp: 'bs 2/23/2010 13:29:54.286'!
testReplicator: anObject
	testReplicator := anObject! !

!SCodeSight methodsFor: 'distribution - messages' stamp: 'bs 8/11/2010 16:31:10.65'!
testResult: aTestResult
	self csTestRunner 
		result: aTestResult;
		updateResults;
		updateResultsInHistory.! !

!SCodeSight methodsFor: 'distribution - messages' stamp: 'bs 10/7/2010 14:29:43.972'!
testResult: aTestResult testCoverage: testsToCoverageData
	| aSightEvent aTestMethod |
	testsToCoverageData keysAndValuesDo: [ :aTestName :coverageData |
		aTestMethod := CompiledMethod fromQualifiedName: aTestName.
		coverageData keysAndValuesDo: [ :aMethodName :classSymbols | 
			aTestMethod 
				called: (CompiledMethod fromQualifiedName: aMethodName) unwrappedMethod
				receiverClasses: (classSymbols collect: [ :ea | Smalltalk classNamed: ea ]) ]
		].
	aSightEvent := self openEvents next.
	aSightEvent testResult: aTestResult.
	self postprocess: aSightEvent.! !

!SCodeSight methodsFor: 'distribution - modes' stamp: 'mt 2/15/2011 18:03:30.277'!
toggleOperationMode

	self runsDistributed
		ifTrue: [ self switchToStandaloneMode ]
		ifFalse: [ self switchToDistributedMode ].
		
	self changed: #operationModeToggled.! !

!SCodeSight methodsFor: 'system installation' stamp: 'mt 2/15/2011 17:48:04.792'!
toggleSystemInstallation

	self isSystemInstance
		ifTrue: [ self uninstallFromSystem ]
		ifFalse: [ self installIntoSystem ].
		
	
	! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'mt 2/23/2011 09:19:42.725'!
turnOffDistributedMode
	self actor stop.
	self testActorId close.
	self testActorId: nil.
	self maintenanceActorId close.
	self maintenanceActorId: nil.
	self testReplicator stopReplicaAndCleanUp.
	self testReplicator: nil.
	self maintenanceReplicator stopReplicaAndCleanUp.
	self maintenanceReplicator: nil.
	self openEvents removeAll.! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'bs 3/2/2010 21:44:36.47'!
turnOffStandaloneMode! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'bs 8/11/2010 15:21:49.789'!
turnOnDistributedMode
	| runningProcessId tmpTestReplicator tmpMaintenanceReplicator |
	tmpTestReplicator := (SReplicator newTestReplicaOnPort: self testActorPort).
	tmpMaintenanceReplicator := (SReplicator newMaintenanceReplicaOnPort: self maintenanceActorPort).
	
	runningProcessId := self runningProcessId.
	SmalltalkImage current snapshot: true andQuit: false.
	"check whether this is the process that created the replica"
	(runningProcessId == self runningProcessId) 
		ifTrue: [
			tmpTestReplicator createAndStartReplica.
			
			SmalltalkImage current snapshot: true andQuit: false.
			(runningProcessId == self runningProcessId) 
				ifTrue: [
					tmpMaintenanceReplicator createAndStartReplica.
					self testActorId: (ActorId localhostPort: self testActorPort).
					self testReplicator: tmpTestReplicator.
					self maintenanceActorId: (ActorId localhostPort: self maintenanceActorPort).
					self maintenanceReplicator: tmpMaintenanceReplicator.
					self startDevelopmentActor.
					self makeDistributed. ]
				ifFalse: [
					self startMaintenanceActor ] ]
		ifFalse: [
			self startTestActor ].! !

!SCodeSight methodsFor: 'distribution - modes - private' stamp: 'mt 2/23/2011 09:14:37.914'!
turnOnStandaloneMode

	self makeStandalone.! !

!SCodeSight methodsFor: 'system installation' stamp: 'mt 2/23/2011 10:12:09.789'!
uninstallFromSystem

	self csTestRunner removeDependent: SAbstractInfo instance.
	SAbstractInfo reset.
	self isSystemInstance: false.
		
	
	! !

!SCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:46.751'!
uninstrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor uninstrumentPackage: aPackageInfo ]! !

!SCodeSight methodsFor: 'event processing' stamp: 'mt 2/14/2011 13:48:27.426'!
update: aSymbol
	
	super update: aSymbol.
	
	aSymbol = #tddAutoRunMode
		ifTrue: [self tddAutoModeToggled].! !

SCodeSight subclass: #SCodeSightForDistributionRequestTests
	instanceVariableNames: 'distributionTestsDevelopmentActor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution-Tests'!

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:57:09.767'!
developmentActorId
	^ self distributionTestsDevelopmentActor ! !

!SCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:18.663'!
distributionTestsDevelopmentActor
	^ distributionTestsDevelopmentActor 
		ifNil: [ distributionTestsDevelopmentActor := SDistributionTestsDevelopmentActor new ]! !

Object subclass: #SCodeSightPanel
	instanceVariableNames: 'codeSight cleanUpOnClose'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Ui'!

!SCodeSightPanel commentStamp: 'mt 2/21/2011 10:44:27.476' prior: 0!
Simple front-end to control an SCodeSight instance. A new instance of SCodeSight will be created on #open. 

You can reuse an SCodeSight instance with #openWith:.!

!SCodeSightPanel class methodsFor: 'instance creation' stamp: 'mt 2/21/2011 10:50:15.241'!
open

	^ (self openWith: SCodeSight new)
		cleanUpOnClose: true "new instance needs to be cleaned-up"! !

!SCodeSightPanel class methodsFor: 'instance creation' stamp: 'mt 2/21/2011 10:44:43.605'!
openWith: aCodeSight

	^ self new
		codeSight: aCodeSight;
		open;
		yourself! !

!SCodeSightPanel methodsFor: 'ui - building' stamp: 'mt 2/21/2011 10:33:29.035'!
buildControlPanelWith: aBuilder

	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self toolButtons collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: #hasCodeSight
				yourself ]);
		yourself! !

!SCodeSightPanel methodsFor: 'ui - building' stamp: 'mt 2/15/2011 18:00:06.817'!
buildWith: aBuilder

	| windowSpec |
	windowSpec := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	
	^aBuilder build: windowSpec
	! !

!SCodeSightPanel methodsFor: 'accessing' stamp: 'mt 2/21/2011 10:49:40.202'!
cleanUpOnClose
	"Perform a clean-up on the codeSight instance if the GUI window is closed?"
	
	^ cleanUpOnClose ifNil: [cleanUpOnClose := false]! !

!SCodeSightPanel methodsFor: 'accessing' stamp: 'mt 2/21/2011 10:47:44.316'!
cleanUpOnClose: aBoolean

	cleanUpOnClose := aBoolean.! !

!SCodeSightPanel methodsFor: 'ui - open/close' stamp: 'mt 2/21/2011 10:53:48.026'!
close

	self cleanUpOnClose
		ifTrue: [self codeSight ifNotNil: [:cs | cs cleanUp]].! !

!SCodeSightPanel methodsFor: 'accessing' stamp: 'mt 2/15/2011 17:42:09.559'!
codeSight

	^ codeSight! !

!SCodeSightPanel methodsFor: 'accessing' stamp: 'mt 2/21/2011 10:56:34.021'!
codeSight: aCodeSightObject

	codeSight ifNotNil: [
		self cleanUpOnClose
			ifTrue: [Error signal: 'You cannot switch the CodeSight instance.'].
			
		codeSight removeDependent: self].

	codeSight := aCodeSightObject.
	
	codeSight ifNotNil: [codeSight addDependent: self].
	
	"Update everything that depends on the codeSight instance."
	self
		changed: #hasCodeSight;
		changed: #operationModeLabel;
		changed: #installUninstallLabel.! !

!SCodeSightPanel methodsFor: 'ui - building' stamp: 'mt 2/15/2011 17:59:55.764'!
extent

	^ 200 @ 250! !

!SCodeSightPanel methodsFor: 'testing' stamp: 'mt 2/21/2011 10:33:10.64'!
hasCodeSight
	"Check whether a codeSight instance was set or not. Used for enabled/disabled state of buttons."
	
	^ self codeSight notNil! !

!SCodeSightPanel methodsFor: 'labels' stamp: 'mt 2/21/2011 10:34:16.981'!
installUninstallLabel

	self hasCodeSight
		ifFalse: [^ 'system instance state'].

	^ self codeSight isSystemInstance
		ifTrue: [ 'uninstall from system' ]
		ifFalse: [ 'install into system' ].! !

!SCodeSightPanel methodsFor: 'ui - building' stamp: 'mt 2/15/2011 17:59:52.506'!
label

	^ 'CodeSight'! !

!SCodeSightPanel methodsFor: 'ui - open/close' stamp: 'mt 2/15/2011 17:55:44.077'!
open

	^ ToolBuilder open: self! !

!SCodeSightPanel methodsFor: 'actions' stamp: 'mt 2/21/2011 10:31:35.314'!
openPackageChooser

	^ SPackageChooser openWith: self codeSight! !

!SCodeSightPanel methodsFor: 'actions' stamp: 'mt 2/15/2011 17:41:05.467'!
openTestDriver! !

!SCodeSightPanel methodsFor: 'actions' stamp: 'mt 2/15/2011 17:54:50.558'!
openTestRunner

	^ self codeSight csTestRunner open! !

!SCodeSightPanel methodsFor: 'labels' stamp: 'mt 2/21/2011 10:34:10.225'!
operationModeLabel

	self hasCodeSight
		ifFalse: [^ 'operation mode'].
		
	^ self codeSight runsDistributed
		ifTrue: [ 'switch to standalone mode' ]
		ifFalse: [ 'switch to distribution mode' ]! !

!SCodeSightPanel methodsFor: 'actions' stamp: 'mt 2/15/2011 17:59:02.179'!
toggleOperationMode

	self codeSight toggleOperationMode.! !

!SCodeSightPanel methodsFor: 'actions' stamp: 'mt 2/15/2011 17:59:05.883'!
toggleSystemInstallation

	self codeSight toggleSystemInstallation.! !

!SCodeSightPanel methodsFor: 'ui - building' stamp: 'mt 2/15/2011 17:41:05.674'!
toolButtons
	^ #(( 'Package Chooser' #openPackageChooser )
		( 'Test Runner' #openTestRunner )
		( 'Test Driver' #openTestDriver )
		( #installUninstallLabel #toggleSystemInstallation )
		( #operationModeLabel #toggleOperationMode ))! !

!SCodeSightPanel methodsFor: 'updating' stamp: 'mt 2/15/2011 17:54:06.65'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = #operationModeToggled ifTrue: [self changed: #operationModeLabel].
	aSymbol = #systemInstanceToggled ifTrue: [self changed: #installUninstallLabel].! !

Object subclass: #SDistributionTestsDevelopmentActor
	instanceVariableNames: 'receivedTestResult receivedTestCoverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution-Tests'!

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.603'!
receivedTestCoverage
	^ receivedTestCoverage! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.605'!
receivedTestResult 
	^ receivedTestResult! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.607'!
testCoverage: coverageData
	receivedTestCoverage := coverageData! !

!SDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.609'!
testResult: aTestResult
	receivedTestResult := aTestResult! !

Object subclass: #SFailedExpressionStyler
	instanceVariableNames: ''
	classVariableNames: 'RegisteredInstance'
	poolDictionaries: ''
	category: 'Sight-Cst-Ui-Text'!

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
initialize
	"self initialize"
	super initialize.
	self load.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:33'!
load
	self registeredInstance: self new.
	SwaSourceTextStyler instance registerStyler: self registeredInstance.! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance
	^ RegisteredInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance: anInstance
	^ RegisteredInstance := anInstance! !

!SFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
unload
	SwaSourceTextStyler instance unregisterStyler: self registeredInstance.
	self registeredInstance: nil.! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 7/4/2010 12:48:54.42'!
createFailedExpressionAttribute
	^ STextBackgroundColor new
		color: Color red darker;
		yourself! !

!SFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 12/31/2009 16:24'!
styleSource: aText of: aCompiledMethod
	| styledSourceText failedExpressionTextInterval |
	styledSourceText := aText.
	(aCompiledMethod isTestMethod and: [aCompiledMethod hasTestFailed])
		ifTrue: [
			failedExpressionTextInterval := aCompiledMethod failedExpressionInterval.
			styledSourceText 
				addAttribute: self createFailedExpressionAttribute
				from: failedExpressionTextInterval first
				to: failedExpressionTextInterval last ].
	^ styledSourceText.! !

Object subclass: #SFixedAnalyzer
	instanceVariableNames: 'package codeRevisionsCoverage installer filenames methodModificationsOverTime methodAdditionsOverTime fixedRelationshipOverTime fixedCoverageDeltas codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision
	^ self methodAdditionsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision put: methodNames
	^ self methodAdditionsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 15:25:49.789'!
analyzeCoverageForVersion: aVersionNumber	
	self codeSight addToManagedPackages: self package.
	self csTestRunner activateTracing.
	self runAllTestsOfPackage.
	self csTestRunner deactivateTracing.
	self gatherCoverageDataAndStoreAsVersion: aVersionNumber.
	self codeSight removeFromManagedPackages: self package.
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzeCoverageOverTime
	| alreadyRunThrough |
	alreadyRunThrough := 0.
	self filenames withIndexDo: [:filename :index |
		(index > alreadyRunThrough) ifTrue: [
			Transcript cr; show: index asString, ' started ... '.
			self installer uninstallPackage.
			Transcript show: 'uninstalled ...'.
			self installer installFromCache: filename.
			Transcript show: 'installed ...'.
			self analyzeCoverageForVersion: index.
			Transcript clear. ] ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 11:23:37.678'!
analyzeFixedRelationshipsOverTime
	|  madeItRunInRevisions revision methodsAdded methodsModified madeItRun fixedTests previousRevision previousCoveringTestMethods coverageDifference previousMadeItRun newTests newlyCoveringTests notNewButNewlyCoveringTests newAndNewlyCoveringTests |
	
	madeItRunInRevisions := fixedRelationshipOverTime := Dictionary new.
	filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		revision := self codeRevisionsCoverage at: index.
		methodsAdded := self addedMethodsAt: index.
		methodsModified := self modifiedMethodsAt: index.
	
		madeItRun := madeItRunInRevisions at: index put: Dictionary new.
	 
		revision keysAndValuesDo: [:appMethod :coveringTestMethods |
			fixedTests := madeItRun at: appMethod put: Set new.
			(methodsAdded includes: appMethod)
				ifTrue: [
					fixedTests addAll: coveringTestMethods.
					"entweder ist der test neu, falls nicht, muss ich aber von einem verschieben von funktionalitt ausgehen" ]
				ifFalse: [
					newTests := nil. "all tests that are in new this revision"
					previousRevision := self codeRevisionsCoverage at: (index - 1).
					previousCoveringTestMethods := previousRevision at: appMethod.
					coverageDifference := coveringTestMethods difference: previousCoveringTestMethods.
					
					previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
					fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods).
					
					newlyCoveringTests := coveringTestMethods difference: previousCoveringTestMethods.
					notNewButNewlyCoveringTests := newlyCoveringTests difference: newTests.
					"von diesen - notNewButNewlyCoveringTests; 
					 alle tests, die vor der erstellung dieser methode schon existiert haben,
					 da mglicherweise ein verschieben von funktionalitt statt gefunden hat"
					
					(methodsModified includes: appMethod)
						ifTrue: [ 
							newAndNewlyCoveringTests := newlyCoveringTests intersection: newTests.
							fixedTests addAll: newAndNewlyCoveringTests ]
						"ifFalse: [
							previousCoveringTestMethods isEmpty
								ifTrue: [
									fixedTests addAll: coverageDifference ]
								ifFalse: [
									previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
									fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods) ].
						 	]."
				 	].
			]. 
		Transcript clear ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:35'!
analyzeForMethodModifications
	| modifiedMethodNames previousRevision currentRevision patch modifications |
	previousRevision := nil.
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		currentRevision := self installer readVersionFromCache: filename.
		modifiedMethodNames := self modifiedMethodsAt: index put: Set new.
		previousRevision ifNotNil: [
			patch := previousRevision package snapshot patchRelativeToBase: currentRevision snapshot.
			modifications := patch operations select: [:ea | ea isModification and: [ea obsoletion isMethodDefinition]].
			modifications do: [:ea | 
				modifiedMethodNames add: (ea obsoletion className, ' >> #', ea obsoletion selector) ] ].
		previousRevision := currentRevision.
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 13:02'!
analyzeForMethodsAdded
	| coverage previousCoverage addedMethodNames |
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		coverage := self codeRevisionsCoverage at: index.
		(index = 1) 
			ifTrue: [ self addedMethodsAt: index put: coverage keys ]
			ifFalse: [
				previousCoverage := self codeRevisionsCoverage at: (index - 1).
				addedMethodNames := coverage keys reject: [:ea | previousCoverage includesKey: ea].
				self addedMethodsAt: index put: addedMethodNames ].
		Transcript clear. ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:41'!
analyzeModificationsOverTime

	self 
		analyzeForMethodModifications;
		analyzeForMethodsAdded.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzePackage: aPackageInfo
	package := aPackageInfo..
	self 
		fetchVersionsToLocalCache;
		analyzeCoverageOverTime;
		analyzeModificationsOverTime;
		analyzeFixedRelationshipsOverTime.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:12'!
analyzePackage: aPackageInfo asVersion: aVersionNumber
	
	package := aPackageInfo.
	
	self 
		instrumentPackage;
		runAllTestsOfPackage;
		uninstrumentPackage;
		gatherCoverageDataAndStoreAsVersion: aVersionNumber
	! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:35'!
classesAndMetaclasses
	^ package classes gather: [ :aClass | {aClass. aClass class} ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:08'!
codeRevisionsCoverage
	^ codeRevisionsCoverage ifNil: [ codeRevisionsCoverage := Dictionary new. ]
	! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:15.181'!
codeSight
	codeSight 
		ifNil: [
			codeSight := SCodeSight new.
			codeSight instrumentor: codeSight createWeavingInstrumentor ].
	^ codeSight! !

!SFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:57:50.644'!
codeSight: anObject
	codeSight := anObject! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:14'!
computeFixedCoverageDeltas
	| deltasInRev coveringTests |
	self codeRevisionsCoverage keysAndValuesDo: [:revisionIndex :coverageInRev |
		deltasInRev := self fixedCoverageDeltas at: revisionIndex put: Dictionary new.
		(self fixedRelationshipAt: revisionIndex) keysAndValuesDo: [:appMethod :fixedTests | 
			coveringTests := coverageInRev at: appMethod.
			coveringTests ifNotEmpty: [
				deltasInRev at: appMethod put: (fixedTests size / coveringTests size) ].
	 	].
	].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/9/2010 14:42:03.151'!
deltas
	^ deltas ifNil: [deltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
fetchVersionsToLocalCache
	
	self filenames: self installer fetchVersionsToLocalCache.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames
	^ filenames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames: aCollection
	filenames := aCollection! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:44'!
fixedCoverageDeltas
	^ fixedCoverageDeltas ifNil: [fixedCoverageDeltas := Dictionary new.]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:49'!
fixedCoverageDeltasAvg
	| deltasRevisionAvg |
	deltasRevisionAvg := Dictionary new.
	self fixedCoverageDeltas keysAndValuesDo: [:revisionIndex :deltasInRev |
		deltasRevisionAvg at: revisionIndex put: (deltasInRev values sum / deltasInRev values size) asFloat ].
	^ deltasRevisionAvg.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:54'!
fixedRelationshipAt: revisionIndex
	^ self fixedRelationshipOverTime at: revisionIndex! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:55'!
fixedRelationshipAt: revisionIndex put: methodToFixedTestsDict
	^ self fixedRelationshipOverTime at: revisionIndex put: methodToFixedTestsDict.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:53'!
fixedRelationshipOverTime
	^ fixedRelationshipOverTime ifNil: [ fixedRelationshipOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:11'!
gatherCoverageDataAndStoreAsVersion: aVersionNumber
	| codeCoverage |
	codeCoverage := self codeRevisionsCoverage at: aVersionNumber put: Dictionary new.
	self nonTestMethods do: [ :aCompiledMethod |
		codeCoverage 
			at: (aCompiledMethod qualifiedName)
			put: (aCompiledMethod coveringTestMethods collect: [:ea | ea qualifiedName]) ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:27.451'!
installer 
	^ installer ifNil: [ installer := SMczInstaller newForPackageNamed: self package packageName ].! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.323'!
instrumentPackage
	
	SWrappingInstrumentor systemInstrumentor instrumentPackage: package.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:12'!
methodAdditionsOverTime
	^ methodAdditionsOverTime ifNil: [ methodAdditionsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:11'!
methodModificationsOverTime
	^ methodModificationsOverTime ifNil: [ methodModificationsOverTime := Dictionary new. ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision
	^ self methodModificationsOverTime at: revision! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision put: methodNames
	^ self methodModificationsOverTime at: revision put: methodNames! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:59'!
nonTestMethods
	^ self classesAndMetaclasses gather: [ :aClass | 
		aClass methodDict values reject: [:aCompiledMethod | 
			aCompiledMethod selector isTestSelector ] ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package
	^ package! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package: aPackageInfo
	package := aPackageInfo! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/20/2010 22:54:27.917'!
runAllTestsOfPackage	
	| aTestRunner aSuite |
	aTestRunner := SCoverageTestRunner new.
	aSuite := TestSuite new.
	self testClasses do: [ :aTestClass | 
		aTestClass selectors 
			select: [:ea | ea isTestSelector ] 
			thenDo: [:ea | aSuite addTest: (aTestClass selector: ea) ]].
	aTestRunner runSuite: aSuite.! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:21'!
testClasses
	^ package classes select: [ :aClass | aClass inheritsFrom: TestCase ]! !

!SFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:47:14.317'!
uninstrumentPackage
	
	SWrappingInstrumentor systemInstrumentor uninstrumentPackage: package.! !

Object subclass: #SMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!SMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #SMczInspectorOld
	instanceVariableNames: 'isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

SMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

!SMczInspectorOld class methodsFor: 'examples' stamp: 'bs 7/4/2010 12:48:25.966'!
exampleVersions
	| instance result repo |
	exampleCache ifNotNilDo: [ :c | ^ c ].
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames select: [ :filename | filename startsWith: 'Xpf-CodeTalk' ]) 
		do: 
			[ :filename | 
			instance zip: (SMczCache 
					cacheAt: filename
					ifNoneGetFrom: repo).
			instance loadVersionInfo.
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: 
				[ :bin | 
				
				[ (DataStream on: bin contentStream) next definitions 
					select: 
						[ :def | 
						def isMethodDefinition and: [ def className = 'XpfCodeTalk' and: [ def selector = #todo ] ] ]
					thenDo: 
						[ :def | 
						result add: (CSRemoteMethodVersion 
								repository: repo
								info: instance info
								definition: def) ] ] 
					on: Error
					do: 
						[ :fallThrough | 
						"Unknown content in snapshot.bin!!"
						 ] ] ]
		displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!SMczInspectorOld methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 17:15'!
filenames
	| packageName aHttpRepository | 
	
	packageName := self repositories first value.
	aHttpRepository := self repositories first key.
	^ self
		filterFileNames: aHttpRepository readableFileNames
		packages: packageName.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 18:06'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self inspectVersion.
		shouldInspectDefs := self followAncestors not
			or: [self currentAncestors isEmpty]
			or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
		shouldInspectDefs ifTrue: [self inspectDefinitions].
		self followAncestors ifTrue: [self updateCurrentAncestry]].! !

!SMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!SMczInspectorOld methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInspectorOld methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!SMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!SMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!SMczInspectorOld methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!SMczInspectorOld methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #SMczInstaller
	instanceVariableNames: 'repository packageName currentStep maxSteps currentAncestors reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/26/2009 10:14'!
newForPackageNamed: aString

	| aPackage instance repos httpRepo |
	aPackage := MCPackage named: aString.
	aPackage hasWorkingCopy ifFalse: [^ nil].
	repos := aPackage workingCopy repositoryGroup repositories.
	httpRepo := repos detect: [:r | r isKindOf: MCHttpRepository ].
	
	instance := self new.
	instance 
		repository: httpRepo;
		packageName: aPackage name.
	^ instance ! !

!SMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/20/2009 17:29'!
newForPackagesNamed: packageName inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		repository: mcRepository;
		packageName: packageName.
	^ instance! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:36'!
cacheAt: aFileName

	^ self cacheDirectory readOnlyFileNamed: aFileName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:35'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
fetchVersionsToLocalCache
	| filenames |
	filenames := (self filterFileNames: self repository readableFileNames).	
	filenames do: [:filename |	
		self reader readFile: filename from: self repository ].
	^ filenames! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
filterFileNames: someFileNames
	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename | self packageMatchesFileName: filename].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ result reversed! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:53:45.547'!
installFromCache: aFileName
	MczInstaller installStream: (self cacheAt: aFileName).! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:29'!
packageMatchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: self packageName) ifFalse: [^ false].
	fileName size = self packageName size ifTrue: [true].
	followingChar := fileName at: self packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName

	^ packageName! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName: aName

	^ packageName := aName! !

!SMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:28'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/23/2009 21:36'!
readVersionFromCache: aFileName
	^ MCMczReader versionFromStream: (self cacheAt: aFileName)! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:48:28.112'!
reader
	^ reader ifNil: [ reader := SMczReader new ]! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository

	^ repository! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository: aHttpRepo
	repository := aHttpRepo.! !

!SMczInstaller methodsFor: 'accessing' stamp: 'bs 11/21/2009 20:52'!
uninstallPackage
	
	(PackageInfo named: self packageName) classes do: [:aClass | aClass removeFromSystem ]! !

Object subclass: #SMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SMczReader commentStamp: 'mt 6/3/2009 11:04' prior: 0!
This is a simplified version of the McMczReader.!

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 16:59'!
definitions

	"if it does not work, look at loadDefinitions"
	^ definitions ifNil: [
		(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[definitions := (DataStream on: bin contentStream) next definitions]
				on: Error
				do: [:fallThrough | definitions := OrderedCollection new]]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!SMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!SMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:00'!
info

	^ info ifNil: [info := self extractInfoFrom: (self parseMember: 'version')]! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!SMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!SMczReader methodsFor: 'public' stamp: 'bs 7/4/2010 12:48:25.981'!
readFile: aFilename from: aRepository 
	self
		repository: aRepository;
		zip: (SMczCache 
				cacheAt: aFilename
				ifNoneGetFrom: aRepository)! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!SMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #SPackageChooser
	instanceVariableNames: 'list listSelections codeSight window selectedPackageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Ui'!

!SPackageChooser commentStamp: 'mt 2/21/2011 10:17:20' prior: 0!
A simple front-end to choose packages to be managed by CodeSight.!

!SPackageChooser class methodsFor: 'instance creation' stamp: 'mt 2/21/2011 10:27:16.54'!
openWith: aCodeSight

	^ self new
		open;
		codeSight: aCodeSight;
		yourself  ! !

!SPackageChooser methodsFor: 'ui - building' stamp: 'mt 2/21/2011 12:07:24.38'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Package Chooser';
		children: OrderedCollection new;
		closeAction: #close.
		
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getIndex: #selectedPackageIndex;
		setIndex: #selectedPackageIndex:;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec! !

!SPackageChooser methodsFor: 'ui - open/close' stamp: 'mt 2/21/2011 11:31:06.033'!
close
! !

!SPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight
	^ codeSight! !

!SPackageChooser methodsFor: 'accessing' stamp: 'mt 2/21/2011 10:46:40.858'!
codeSight: aCodeSightObject

	codeSight ifNotNil: [codeSight removeDependent: self].

	codeSight := aCodeSightObject.
	
	codeSight ifNotNil: [codeSight addDependent: self].
	
	"Update everything that depends on the codeSight instance."
	self changed: #hasCodeSight.! !

!SPackageChooser methodsFor: 'testing' stamp: 'mt 2/21/2011 10:57:38.791'!
hasCodeSight
	"Check whether a codeSight instance was set or not. Used for enabled/disabled state of buttons."
	
	^ self codeSight notNil! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 11:21:29.149'!
list

	^ list ifNil: [list := self packageNamesSorted]! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 11:14:41.701'!
list: aCollection

	list := aCollection.
	self changed: #list.! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 11:17:58.797'!
listSelectionAt: index

	^ self listSelections at: index! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 11:57:12.047'!
listSelectionAt: index put: isMarked

	| selectedPackage | 
	(self listSelections at: index) = isMarked
		ifTrue: [^ self].

	selectedPackage := self packageAt: index.

	self listSelections at: index put: (isMarked
		ifTrue: [self registerPackage: selectedPackage]
		ifFalse: [self unregisterPackage: selectedPackage. false]).

	self changed: #packageSelected.! !

!SPackageChooser methodsFor: 'accessing - private' stamp: 'mt 2/21/2011 12:03:53.508'!
listSelections

	"Lazy initialization."
	^ listSelections ifNil: [self list
		ifNil: []
		ifNotNil: [
			listSelections := self list collect: [:each |
				self registeredPackages includes: (self packageNamed: each)]]]! !

!SPackageChooser methodsFor: 'accessing - private' stamp: 'mt 2/21/2011 11:19:22.304'!
listSelections: aDictionary

	listSelections := aDictionary.
	self changed: #packageSelected.! !

!SPackageChooser methodsFor: 'ui - open/close' stamp: 'mt 2/21/2011 10:34:57.747'!
open
	
	^ ToolBuilder open: self! !

!SPackageChooser methodsFor: 'accessing - private' stamp: 'mt 2/21/2011 11:22:52.632'!
packageAt: index

	^ self packageNamed: (self list at: index)! !

!SPackageChooser methodsFor: 'accessing - private' stamp: 'mt 2/21/2011 11:22:29.937'!
packageNamed: aName

	^ PackageOrganizer default packageNamed: aName ifAbsent: []! !

!SPackageChooser methodsFor: 'accessing - private' stamp: 'mt 2/21/2011 11:13:12.111'!
packageNamesSorted
	
	| packageNames criticalPackages |
	packageNames := PackageOrganizer default packages 
			collect: [ :packageInfo | packageInfo packageName ].
	
	criticalPackages := #('Collections' 'CollectionsTests' 'Kernel' 'KernelTests' 'Graphics' 'GraphicsTests' 'ST80' 'SUnit' 'System').
	
	^ (packageNames reject: [:package | 
		criticalPackages includes: package]) sort! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 11:25:28.152'!
refresh
	
	self
		list: nil;
		listSelections: nil.! !

!SPackageChooser methodsFor: 'actions - CodeSight' stamp: 'bs 3/2/2011 21:46:17.021'!
registerPackage: aPackage

	self hasCodeSight ifTrue: [
		self codeSight addToManagedPackages: aPackage ] ! !

!SPackageChooser methodsFor: 'actions - CodeSight' stamp: 'mt 2/21/2011 11:06:39.268'!
registeredPackages

	^ self hasCodeSight
		ifTrue: [self codeSight managedPackages]
		ifFalse: [#()]! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 12:07:10.715'!
selectedPackageIndex

	^ selectedPackageIndex ifNil: [selectedPackageIndex := 0]! !

!SPackageChooser methodsFor: 'accessing - model' stamp: 'mt 2/21/2011 12:07:02.27'!
selectedPackageIndex: anInteger

	selectedPackageIndex := anInteger.
	self changed: #selectedPackageIndex.! !

!SPackageChooser methodsFor: 'actions - CodeSight' stamp: 'mt 2/21/2011 11:29:52.897'!
unregisterPackage: aPackage
	"Returns always true as it does not matter whether a package can be successfully removed."
	
	self hasCodeSight ifTrue: [
		self codeSight removeFromManagedPackages: aPackage].
	
	^ true! !

Object subclass: #SPartialTracingBenchmarker
	instanceVariableNames: 'packageToBenchmark codeSight coveredMethodTestTimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Analyzing'!

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 7/4/2010 12:48:15.202'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: SWeavingInstrumentor new.
	codeSight instrumentor codeSight: codeSight.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 1/24/2010 15:02'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 12:48:15.188'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := SCodeSight new.
	codeSight instrumentor: codeSight createWeavingInstrumentor.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/24/2010 14:39'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:24:40.87'!
benchmarkPartialTracingTimes
	| result testTime activationInstr |
	self halt.
	self codeSight instrumentor instrumentPackage: self packageToBenchmark.
	result := IdentityDictionary new.
	testTime := nil.
	self coveredMethods withIndexDo: [ :m :index |
		Transcript show: index asString; cr.
		Transcript show: 'covering: ',  m coveringTestMethods size asString; cr.
		testTime :=
			(self codeSight instrumentor canInstrument: m selector inClass: m methodClass)
				ifFalse: [ (m coveringTestMethods collect: [ :tm | self coveredMethodTestTimes at: m ]) sum ]
				ifTrue: [
					[ activationInstr := SInstrumentedMethod activationOn: m selector inClass: m methodClass.
					activationInstr install.
					codeSight csTestRunner runAndTraceTestMethods: m coveringTestMethods.
					activationInstr uninstall. ] timeToRunWithoutGC ].
		result at: m put: testTime. ].
	codeSight instrumentor uninstrumentPackage: self packageToBenchmark.
	^ result.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:02.492'!
classesAndMetaclasses
	^ self packageToBenchmark classes flatCollect: [ :c | {c. c class} ]! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight
	^ codeSight! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight: anObject
	codeSight := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 15:45'!
collectAllTestMethods
	^ (self packageToBenchmark classes
		select: [ :c | c isTestCaseClass ])
			flatCollect: [ :c | c testMethods ] ! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.559'!
coveredMethodTestTimes
	^ coveredMethodTestTimes! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.56'!
coveredMethodTestTimes: anObject
	coveredMethodTestTimes := anObject! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:54.897'!
coveredMethods
	^ self nonTestMethods select: [ :m | m hasCoveringTestMethods ].! !

!SPartialTracingBenchmarker methodsFor: 'initialize-release' stamp: 'bs 7/4/2010 12:48:15.195'!
initialize
	super initialize.
	self codeSight: SCodeSight new.
	self codeSight instrumentor: self codeSight createWeavingInstrumentor.! !

!SPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:23.258'!
nonTestMethods
	^ (self classesAndMetaclasses flatCollect: [ :c | c methodDict values ]) select: [ :m | m isTestMethod not ].! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:05'!
packageToBenchmark
	^ packageToBenchmark! !

!SPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:01'!
packageToBenchmark: anObject
	packageToBenchmark := anObject! !

!SPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 8/10/2010 18:24:11.251'!
runAndTraceAllTests
	self codeSight csTestRunner
		runAndTraceTestMethods: self collectAllTestMethods.! !

Object subclass: #SReplicateMessage
	instanceVariableNames: 'command headerBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Distribution'!

!SReplicateMessage class methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:47:20.627'!
receiveFrom: aSocket
	^ self new 
		receiveFrom: aSocket;
		yourself! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/8/2010 20:15:20.805'!
applyCommand
	Compiler evaluate: self commandAsString.! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command
	^ command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command: anObject
	command := anObject! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 13:08:26.15'!
commandAsString
	^ self command! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:30.074'!
headerBytes
	^ headerBytes ifNil: [headerBytes := ByteArray new: self numberOfHeaderBytes]! !

!SReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:20.283'!
numberOfHeaderBytes
	^ 4.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:37:46.473'!
receiveFrom: aSocket
	| bytesToRead bytesOfCommandString |
	bytesToRead := self receiveMessageLengthHeader: aSocket.
	bytesOfCommandString := ByteArray new: bytesToRead.
	aSocket receiveDataInto: bytesOfCommandString.
	self command: bytesOfCommandString asString.
	Transcript show: 'received command: ', self commandAsString; cr.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:36:12.351'!
receiveMessageLengthHeader: aSocket

	aSocket receiveDataInto: self headerBytes.
	^ self headerBytes unsignedLongAt: 1 bigEndian: true.! !

!SReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:59:14.146'!
sendOn: aSocket
	| commandString |
	commandString := self commandAsString.
	self headerBytes unsignedLongAt: 1 put: (commandString byteSize) bigEndian: true.
	aSocket sendData: self headerBytes, commandString asByteArray! !

Object subclass: #SStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Debugger'!

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!SStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #STestStatistic
	instanceVariableNames: 'receiverClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

!STestStatistic class methodsFor: 'tracing' stamp: 'bs 7/20/2010 15:32:34.148'!
mayMethodBeInstrumented: aSelector
	^ false
	! !

!STestStatistic methodsFor: 'initialize-release' stamp: 'bs 10/28/2009 15:19'!
addCallInDepth: aNumber
	self flag: #rkrk. "for benchmarking"! !

!STestStatistic methodsFor: 'public' stamp: 'bs 8/11/2010 13:36:05.338'!
addReceiverClass: aClass
	self pvtReceiverClasses add: aClass.! !

!STestStatistic methodsFor: 'public' stamp: 'bs 8/11/2010 13:36:11.022'!
addReceiverClasses: classes
	self pvtReceiverClasses addAll: classes.! !

!STestStatistic methodsFor: 'as yet unclassified' stamp: 'mt 2/15/2011 17:34:38.165'!
printOn: stream

	stream
		cr;
		nextPutAll: 'STestStatistic<Trace:';
		nextPutAll: 'Receivers:';
		print: self receiverClasses;
		nextPut: $>.! !

!STestStatistic methodsFor: 'accessing' stamp: 'bs 8/11/2010 13:35:35.319'!
pvtReceiverClasses
	^ receiverClasses 
		ifNil: [receiverClasses := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!STestStatistic methodsFor: 'accessing' stamp: 'bs 8/11/2010 13:35:54.211'!
receiverClasses
	^ self pvtReceiverClasses asIdentitySet! !

Object subclass: #SdCallgraphNode
	instanceVariableNames: 'id parent children properties requestedProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdCallgraphNode commentStamp: 'mt 3/4/2011 10:33:24.411' prior: 0!
Represents a node in a call graph. Such a node can have a parent (if not the root) node, child nodes, and several information stored.!

SdCallgraphNode subclass: #SdCallgraph
	instanceVariableNames: 'traceEvent isNonDeterministic selectedCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdCallgraph commentStamp: 'mt 7/15/2011 12:47:35.871' prior: 0!
This is a database that stores relevant information about a specific call graph (or call tree) resulting from a test method or arbitrary Smalltalk code execution.

Additionally this is the root of the call tree.

Once a call graph was identified as being non-deterministic, it cannot and must not #run again as no more data can be collected in a consistent way.!

!SdCallgraph class methodsFor: 'instance creation' stamp: 'mp 1/18/2010 17:23'!
on: aTracer

	^ self new
		tracer: aTracer! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 16:34:47.583'!
at: aNumber

	^ self findNodeInSubGraph: aNumber startNode: self! !

!SdCallgraph methodsFor: 'collection api' stamp: 'tfel 5/17/2011 10:46:28.593'!
detect: aBlock

	^ self
		detect: aBlock
		ifNone: [self error: 'Object is not in the collection.']! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 17:09:03.511'!
detect: aBlock ifNone: exceptionBlock

	self do: [:node | (aBlock value: node) ifTrue: [^ node]].
	^ exceptionBlock value! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 16:57:26.113'!
do: aBlock
	
	self traverseCallGraph: self with: [:aNode | aBlock value: aNode].
! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/16/2011 16:23:38.095'!
find: aSelector callOn: aClass number: receiverId

	^ self detect: [:n |
		n receiverId = receiverId
			and: [n clientClass = aClass or: [n receiverClass = aClass]]
			and: [n clientSelector = aSelector]]! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/16/2011 16:24:01.544'!
findAll: aSelector callsOn: aClass number: receiverId

	^ self select: [:n |
		n receiverId = receiverId
			and: [n clientClass = aClass or: [n receiverClass = aClass]]
			and: [n clientSelector = aSelector]]! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:48.859'!
findNodeInSubGraph: aNumber startNode: aNode

	| lastNode |
	aNode children do: [:each | 
		each id = aNumber ifTrue: [^ each].
		each id < aNumber ifTrue: [lastNode := each].
		each id > aNumber ifTrue: [
			lastNode	ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode]]].
	lastNode ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode].
	^ nil! !

!SdCallgraph methodsFor: 'initialization' stamp: 'mt 7/14/2011 17:05:39.99'!
initialize 

	super initialize.	
	id := self rootId.! !

!SdCallgraph methodsFor: 'queries' stamp: 'tfel 5/17/2011 10:55:54.696'!
instantiationOfObjectWithId: anObjectId

	^ self
		detect: [ :node | 
			(node clientSelector = #basicNew) and: [node returnId = anObjectId]]
		ifNone: [ nil ]
! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 12:46:33.36'!
isNonDeterministic

	^ isNonDeterministic ifNil: [isNonDeterministic := false]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 12:46:48.121'!
isNonDeterministic: aBoolean

	isNonDeterministic := aBoolean.! !

!SdCallgraph methodsFor: 'id handling' stamp: 'mt 7/14/2011 15:58:44.205'!
nextId: currentId
	"Calculate the next id based on the given id."
	
	^ currentId + 1! !

!SdCallgraph methodsFor: 'id handling' stamp: 'mt 7/14/2011 15:57:29.4'!
rootId

	^ 0! !

!SdCallgraph methodsFor: 'running' stamp: 'mt 7/17/2011 21:24:47.942'!
run

	self isNonDeterministic ifTrue: [^ nil].
	self traceEvent ifNotNil: [:event | ^ event evaluate].
	^ nil! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/16/2011 16:11:10.447'!
select: aBlock
	
	| result |
	result := OrderedCollection new.
	self do: [:node | (aBlock value: node) ifTrue: [result add: node]].
	^ result! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 17:52:48.492'!
selectedCategories

	^ selectedCategories ifNil: [#()]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 17:49:21.726'!
selectedCategories: someSystemCategories

	selectedCategories := someSystemCategories.! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:27:19.301'!
traceEvent
	"Return the overall context that caused this call tree."
	
	^ traceEvent! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:27:30.674'!
traceEvent: aTraceEvent
	
	traceEvent := aTraceEvent.! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:28.869'!
traverseCallGraph: aNode with: aBlock
	"Prefix Order"
	aNode children do: [:each | 
		aBlock value: each.
		self traverseCallGraph: each with: aBlock].! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:21.755'!
traverseCallGraph: aNode with: aBlock abort: anotherBlock
	"Prefix Order"
	aNode children do: [:each | 
		aBlock value: each.
		(anotherBlock value: each) 
			ifFalse: [self traverseCallGraph: each with: aBlock abort: anotherBlock]].! !

!SdCallgraphNode methodsFor: 'comparing' stamp: 'mt 7/15/2011 11:49:01.516'!
= aNode

	^ (aNode isKindOf: SdCallgraphNode)
		and: [self id == aNode id]
		and: [self children size = aNode children size]
		and: [self children withIndexDo: [:node :index |
			node = (aNode children at: index) ifFalse: [^ false]].
			true]! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:02:18.004'!
children

	^ children! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:58:36.949'!
clientClass

	^ nil! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:58:42.407'!
clientSelector

	^ nil! !

!SdCallgraphNode methodsFor: 'comparing' stamp: 'mt 7/15/2011 11:48:23.935'!
hash

	^ (super hash bitXor: self id hash)
		bitXor: self children hash! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:48.858'!
id

	^ id! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:45.107'!
id: anObject

	id := anObject.! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:03:48.551'!
includesProperty: aSymbol 

	^ properties includesKey: aSymbol! !

!SdCallgraphNode methodsFor: 'initialization' stamp: 'mt 7/15/2011 14:51:40.153'!
initialize

	super initialize.
	
	children := OrderedCollection new.
	properties := Dictionary new.
	requestedProperties := OrderedCollection new.! !

!SdCallgraphNode methodsFor: 'testing' stamp: 'mt 7/15/2011 11:15:32.532'!
isEmpty

	^ self children isEmpty! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:02:10.033'!
parent

	^ parent! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:19:41.211'!
parent: aNode

	parent := aNode.! !

!SdCallgraphNode methodsFor: 'printing' stamp: 'mt 7/15/2011 11:21:57.93'!
printString

	^ 'Node<{1}>' format: {self id}! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:07:57.788'!
properties

	^ properties keys! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:03:55.856'!
removeProperty: aSymbol 

	properties ifNil: [^ self].
	properties removeKey: aSymbol ifAbsent: [].! !

!SdCallgraphNode methodsFor: 'properties - future' stamp: 'mt 7/15/2011 14:51:51.53'!
requestProperty: aSymbol 

	requestedProperties add: aSymbol.! !

!SdCallgraphNode methodsFor: 'properties - future' stamp: 'mt 7/15/2011 14:56:05.095'!
requestedPropertiesSatisfying: aBlock

	[^ requestedProperties select: aBlock]
		ensure: [requestedProperties removeAllSuchThat: aBlock].! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:05.421'!
setProperty: aSymbol toValue: anObject 

	anObject ifNil: [^ self removeProperty: aSymbol].
	properties at: aSymbol put: anObject.! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:10.992'!
valueOfProperty: aSymbol 

	^ self
		valueOfProperty: aSymbol
		ifAbsent: []! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:18.437'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ properties
		at: aSymbol
		ifAbsent: aBlock! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:41:59.618'!
valueOfProperty: aSymbol ifAbsentPut: aBlock

	^ properties
		at: aSymbol
		ifAbsentPut: aBlock! !

SdCallgraphNode subclass: #SdMethodCallNode
	instanceVariableNames: 'callsBefore clientClass clientSelector receiverClass receiverId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdMethodCallNode commentStamp: 'mt 7/16/2011 14:39:20.743' prior: 0!
A node in a callgraph that represents a method call. Important information is cached as instance variables and meant to be updated on the first run when the callgraph is created.

Additional properties need to be filled afterwards and are stored in the properties dictionary.!

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:03.439'!
argumentClasses

	^ self valueOfProperty: #argumentClasses! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:13.407'!
argumentIds

	^ self valueOfProperty: #argumentIds! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:15.303'!
argumentObjectsAfter

	^ self valueOfProperty: #argumentObjectsAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:08.394'!
argumentObjectsBefore

	^ self valueOfProperty: #argumentObjectsBefore! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:20:27.549'!
callsBefore
	"Number of calls of this method that occured before this call in the current context."

	^ callsBefore! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:20:43.316'!
callsBefore: anInteger

	callsBefore := anInteger.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:23.265'!
clientClass
	"Return the class that actually implements #clientSelector."

	^ clientClass! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:25.381'!
clientClass: aClassOrMetaClass

	clientClass := aClassOrMetaClass.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'TM 5/17/2011 11:06:18.583'!
clientMethod

	^ self clientClass >> self clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:22:42.872'!
clientReference

	^ MethodReference class: self clientClass selector: self clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:27.505'!
clientSelector
	"Return the selector that was called in this node. The method is implemented in #clientClass."

	^ clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:29.336'!
clientSelector: anObject
	clientSelector := anObject! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:03.538'!
globalArgumentIds

	((self includesProperty: #argumentClasses) and: [
		self includesProperty: #argumentIds]) ifFalse: [^ #()].

	^ self argumentClasses withIndexCollect: [:cls :idx |
		cls -> (self argumentIds at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 15:50:11.935'!
globalReceiverId

	^ self receiverClass -> self receiverId! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:10.478'!
globalReceiverInstVarIdsAfter

	((self includesProperty: #receiverInstVarClassesAfter) and: [
		self includesProperty: #receiverInstVarIdsAfter]) ifFalse: [^ #()].
	
	^ self receiverInstVarClassesAfter withIndexCollect: [:cls :idx |
		cls -> (self receiverInstVarIdsAfter at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:14.464'!
globalReceiverInstVarIdsBefore

	((self includesProperty: #receiverInstVarClassesBefore) and: [
		self includesProperty: #receiverInstVarIdsBefore]) ifFalse: [^ #()].

	^ self receiverInstVarClassesBefore withIndexCollect: [:cls :idx |
		cls -> (self receiverInstVarIdsBefore at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:04:06.007'!
globalReturnId

	((self includesProperty: #returnClass) and: [
		self includesProperty: #returnId]) ifFalse: [^ nil].

	^ self returnClass -> self returnId! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:46:55.438'!
isInContextWith: aNode
	
	| targetId |
	targetId := aNode globalReceiverId.
	
	^ targetId = self globalReceiverId
		or: [targetId = self globalReturnId]
		or: [self globalReceiverInstVarIdsBefore includes: targetId]
		or: [self globalReceiverInstVarIdsAfter includes: targetId]
		or: [self globalArgumentIds includes: targetId]! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 18:30:51.648'!
isInstantiationOf: aNodeOrClass

	self clientSelector = #basicNew ifFalse: [^ false]. 
	^ aNodeOrClass isBehavior
		ifTrue: [self receiverClass theNonMetaClass = aNodeOrClass]
		ifFalse: [self globalReturnId = aNodeOrClass globalReceiverId]! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:40:22.568'!
isReadOf: aNode

	^ (self isSameObjectAs: aNode) and: [
		(1 to: aNode clientClass instSize) anySatisfy: [:idx |
			self clientMethod readsField: idx]].! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:38:35.095'!
isSameObjectAs: aNode

	^ self globalReceiverId = aNode globalReceiverId! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'tfel 6/3/2011 11:06:07.196'!
isWriteTo: aNode

	^ (self isSameObjectAs: aNode) and: [
		(1 to: aNode clientClass instVarNames size) anySatisfy: [:idx |
			self clientMethod writesField: idx]].! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:32.006'!
receiverClass
	"Return the class of the object that received the message. This class does not have to have the #clientSelector imlemented."
	
	^ receiverClass! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:34.41'!
receiverClass: aClassOrMetaClass

	receiverClass := aClassOrMetaClass.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:53:16.024'!
receiverId
	"Return a number which identifies the receiver object in the space of all objects of the same type, i.e. receiver class. This means that the id can be the same if the #receiverClass is different."
	
	^ receiverId! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:51:12.618'!
receiverId: anInteger

	receiverId := anInteger.! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:47:01.515'!
receiverInstVarClassesAfter

	^ self valueOfProperty: #receiverInstVarClassesAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:47:07.663'!
receiverInstVarClassesBefore

	^ self valueOfProperty: #receiverInstVarClassesBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:46:54.993'!
receiverInstVarIdsAfter

	^ self valueOfProperty: #receiverInstVarIdsAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:46:49.142'!
receiverInstVarIdsBefore

	^ self valueOfProperty: #receiverInstVarIdsBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:09.317'!
receiverObjectAfter

	^ self valueOfProperty: #receiverObjectAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:58.004'!
receiverObjectBefore

	^ self valueOfProperty: #receiverObjectBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:49:50.582'!
returnClass

	^ self valueOfProperty: #returnClass! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:37:11.216'!
returnId

	^ self valueOfProperty: #returnId! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:49:58.297'!
returnObject

	^ self valueOfProperty: #returnObject! !

Object subclass: #SdCallgraphTracer
	instanceVariableNames: 'currentId currentNode classDictionary callgraph isFirstRun tracingMode requestedGlobalProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdCallgraphTracer commentStamp: 'mt 7/15/2011 17:46:43.97' prior: 0!
Collects call tree information. If you do not set #selectedCategories, an auto-detection will happen.

| cgt |
cgt := SdCallgraphTracer new.

"Convenient tracing of source code. Automatic scope detection."
cgt traceSourceCode: 'MarbleMania new'.
cgt callgraph explore.

"Add information to all nodes."
cgt collectGlobalProperties: #(returnClass returnId).
cgt callgraph explore.

"Add profiling information."
cgt profile: #durationPercent.
cgt callgraph explore.

"Visualize it."
(UiTreeView new
	model: (SdCallgraphModel new
		threshold: 0;
		root: cgt callgraph)) openInWorld.
		
"Add information for a specific node. Much faster than collecting for the whole tree."
cgt collectProperties: #(argumentObjects) inNode: aNode.!

!SdCallgraphTracer methodsFor: 'profiling - callbacks' stamp: 'mt 7/15/2011 16:49:14.38'!
addProfileInformation: aValue node: anId

	(self getNode: anId)
		setProperty: self tracingMode
		toValue: aValue.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:04:43.177'!
argumentClasses: dict

	(dict at: #node)
		setProperty: #argumentClasses
		toValue: ((dict at: #arguments) collect: [:arg | arg class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 17:04:04.344'!
argumentIds: dict

	(dict at: #node)
		setProperty: #argumentIds
		toValue: ((dict at: #arguments) collect: [:arg | self objectIdFor: arg]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:05:20.776'!
argumentObjectsAfter: dict

	(dict at: #node)
		setProperty: #argumentObjectsAfter
		toValue: ((dict at: #arguments) collect: [:arg | arg veryDeepCopy]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:05:11.572'!
argumentObjectsBefore: dict

	(dict at: #node)
		setProperty: #argumentObjectsBefore
		toValue: ((dict at: #arguments) collect: [:arg | arg veryDeepCopy]).! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/15/2011 17:51:32.623'!
autoSelectCategories
	"Use the current callgraph to select the categories for tracing."
	
	self callgraph run ifNotNil: [:result |
		self callgraph selectedCategories: (PackageOrganizer default packageOfClass: result class) systemCategories].! !

!SdCallgraphTracer methodsFor: 'OBSOLETE' stamp: 'mt 7/15/2011 10:10:54.145'!
byteCodeCoverageAt: aCallNode

	| wrapper |
	wrapper := SdByteCodeCoverageWrapper 
		on: aCallNode clientSelector 
		inClass: aCallNode clientClass 
		waitingCalls: aCallNode callsBefore.
			
	self trace: {wrapper}.
	^ wrapper data
! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:46:00.123'!
callgraph

	^ callgraph ifNil: [callgraph := SdCallgraph new]! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:45:27.939'!
callgraph: aCallgraph

	callgraph := aCallgraph.! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'TM 5/23/2011 15:48:43.131'!
classDictionary
	"Answer the value of classDictionary"

	^ classDictionary ifNil: [classDictionary := Dictionary new]! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'TM 5/23/2011 15:45:45.955'!
classDictionary: anObject
	"Set the value of classDictionary"

	classDictionary := anObject! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 16:57:58.088'!
collectGlobalProperties: someProperties
	"Collect properties for all nodes."
	
	someProperties ifNil: [^ self].
	
	requestedGlobalProperties := someProperties.
	self tracingMode: #property.
	self trace.
	requestedGlobalProperties := nil.! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 16:54:06.898'!
collectGlobalPropertiesAfterReceiver: receiver arguments: arguments returnValue: result

	(requestedGlobalProperties select: [:symbol |
		self knownPropertiesAfterCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> self currentNode.
					#receiver -> receiver.
					#arguments -> arguments.
					#result -> result})].! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 16:54:56.395'!
collectGlobalPropertiesBeforeReceiver: receiver arguments: arguments

	(requestedGlobalProperties select: [:symbol |
		self knownPropertiesBeforeCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> self currentNode.
					#receiver -> receiver.
					#arguments -> arguments})].! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:28:02.088'!
collectProperties: someProperties inNode: aCallNode
	"For convenience."

	self
		collectProperties: someProperties
		inNodes: {aCallNode}.! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:32:25.347'!
collectProperties: someProperties inNodes: someCallNodes
	"For convenience."

	someCallNodes do: [:node | someProperties do: [:prop |
			node requestProperty: prop]].
	self collectPropertiesInNodes: someCallNodes.! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 15:01:20.988'!
collectPropertiesAfterNode: node receiver: receiver arguments: arguments returnValue: result

	(node requestedPropertiesSatisfying: [:symbol |
		self knownPropertiesAfterCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> node.
					#receiver -> receiver.
					#arguments -> arguments.
					#result -> result})].! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 15:00:23.999'!
collectPropertiesBeforeNode: node receiver: receiver arguments: arguments

	(node requestedPropertiesSatisfying: [:symbol |
		self knownPropertiesBeforeCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> node.
					#receiver -> receiver.
					#arguments -> arguments})].! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:26:44.611'!
collectPropertiesInNode: aCallNode
	
	self collectPropertiesInNodes: {aCallNode}.! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:28:43.817'!
collectPropertiesInNodes: someCallNodes
	"Use the requested properties in the given nodes and collects them. See SdCallgraphNode>>#requestedProperties."
	
	self trace: ((someCallNodes collect: [:callNode |
		(SdSpecificPropertyWrapper on: callNode clientSelector inClass: callNode clientClass)
		ifNotNil: [:wrapper |
			wrapper
				numberOfCallsBefore: callNode callsBefore;
				tracer: self;
				node: callNode]]) reject: [:wrapper | wrapper isNil]).
		! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:01:19.092'!
collectShallowArguments

	self collectGlobalProperties: #(argumentClasses argumentIds).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:13:12.465'!
collectShallowContext
	"A complete shallow context of a method call. Includes references to arguments, return object, isntance variables and the type and id of the receiver."

	self collectGlobalProperties: #(receiverInstVarClassesBefore receiverInstVarIdsBefore receiverInstVarClassesAfter receiverInstVarIdsAfter returnClass returnId argumentClasses argumentIds).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:13:08.65'!
collectShallowReceiver
	"#receiverClass and #receiverId are collected by default. Only shallow scope of object is needed, which means references on objects held by instance variables."

	self collectGlobalProperties: #(receiverInstVarClassesBefore receiverInstVarIdsBefore receiverInstVarClassesAfter receiverInstVarIdsAfter).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:05:39.376'!
collectShallowReturn

	self collectGlobalProperties: #(returnClass returnId).! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/16/2011 14:47:27.644'!
createWrappers
	"Create new wrappers for all selected classes and some special cases. Does not actually install the wrappers. Do this with #installWrappers: then."
	
	| wrappers |
	wrappers := OrderedCollection new.

	self selectedClasses do: [:cls |
		"Special wrappers"
		wrappers add: (self wrapperClass on: #basicNew inClass: cls class withTracer: self).
	
		"Instance-side wrappers."
		cls selectors do: [:selector | 
			wrappers add: (self wrapperClass on: selector inClass: cls withTracer: self)].		
		"Class-side wrappers."
		cls class selectors do: [:selector | 
			wrappers add: (self wrapperClass on: selector inClass: cls class withTracer: self)]].
	
	"Detect non-deterministic behavior."
	wrappers add: (SdNonDeterministicBehaviorNotifier on: #next inClass: Random withTracer: self).

	^ wrappers reject: [:wrapper | wrapper isNil]
	! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mp 1/18/2010 16:59'!
currentId
	^ currentId! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mp 1/18/2010 16:59'!
currentId: anObject
	currentId := anObject! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:15:19.508'!
currentNode

	^ currentNode! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:15:26.189'!
currentNode: aNode

	currentNode := aNode.! !

!SdCallgraphTracer methodsFor: 'OBSOLETE' stamp: 'mt 7/15/2011 10:16:25.804'!
debugAt: aCallNode
	
	aCallNode callsBefore = 0
		ifTrue: [
			[BreakpointManager
				installInClass: aCallNode clientClass
				selector: aCallNode clientSelector.
				self callgraph run] ensure: [
					BreakpointManager unInstall: aCallNode clientClass >> aCallNode clientSelector]]
		ifFalse: [ | wrapper |
			wrapper := SdDebugWrapper 
				on: aCallNode clientSelector 
				inClass: aCallNode clientClass 
				waitingCalls: aCallNode callsBefore.
			self trace: {wrapper}].! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/15/2011 12:57:47.822'!
getNode: anId

	^ self currentNode id = anId
		ifTrue: [self currentNode]
		ifFalse: [self callgraph at: anId]! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 09:57:54.603'!
installWrappers: someWrappers
	
	someWrappers do: [:each | each install].! !

!SdCallgraphTracer methodsFor: 'testing' stamp: 'mt 7/15/2011 13:05:34.34'!
isFirstRun

	^ isFirstRun! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/16/2011 15:45:34.194'!
knownPropertiesAfterCall
	"Return all known properties that can be collected after a method call."
	
	^ #(
		returnClass "type of the returned object"
		returnObject "state copy of the returned object"
		returnId "serial identifier for the returned object in context of its type"
		receiverObjectAfter "state copy of the message receiving object AFTER the method call"
		receiverInstVarClassesAfter "types of the instance variables AFTER the method call"
		receiverInstVarIdsAfter "serial identifier for the instance variables AFTER the method call"
		argumentObjectsAfter "state copies of the message arguments AFTER the method class")! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/16/2011 15:46:00.053'!
knownPropertiesBeforeCall
	"Return all known properties that can be collected before a method call."
	
	^ #(
		receiverClass "type of the message receiving object"
		receiverObjectBefore "state copy of the message receiving object BEFORE the method call"
		receiverInstVarClassesBefore "types of the instance variables BEFORE the method call"
		receiverInstVarIdsBefore "serial identifier for the instance variables BEFORE the method call"
		argumentClasses "types of the message arguments"
		argumentObjectsBefore "state copies of the message arguments BEFORE the method class"
		argumentIds "serial identifier for the arguments in context of the argument class")! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 16:01:02.772'!
nextCallNodeOn: aClass with: aSelector receiverObject: theObject arguments: anArray callsBefore: aNumber
	
	| nextId node |
	nextId := self callgraph nextId: self currentId.

	node := isFirstRun
		"Callgraph is filled the first time."
		ifTrue: [self currentNode children add: (SdMethodCallNode new
			id: nextId;
			clientClass: aClass;
			clientSelector: aSelector;
			parent: self currentNode;
			receiverClass: theObject class;
			receiverId: (self objectIdFor: theObject);
			callsBefore: aNumber)]
		"Additional run adds information to all nodes."
		ifFalse: [self currentNode children
			detect: [:childNode | childNode id = nextId]
			ifNone: [SdNonDeterministicBehaviorDetected signal]].
	
	self
		currentNode: node;
		currentId: nextId.

	^ node id! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 16:22:33.5'!
objectIdFor: anObject
	"All objects that are given into this method will be held until tracing is over. This is needed to get the correct implementation of object id but also needs more memory."
	
	| instances |
	instances := self classDictionary at: anObject class name ifAbsentPut: [OrderedCollection new].
	^ instances
		identityIndexOf: anObject
		ifAbsent: [instances add: anObject. instances size]! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:00:47.692'!
postProfilingCounts

	| bag |
	bag := Bag new.
	self callgraph do: [:node | bag add: node clientClass -> node clientSelector.
		node
			setProperty: #counts
			toValue: (bag occurrencesOf: node clientClass -> node clientSelector)].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:01:00.413'!
postProfilingMilliSeconds

	| duration |
	self callgraph do: [:node | 
		duration := node valueOfProperty: #duration.
		node setProperty: #duration toValue: duration asMilliSeconds].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:01:19.933'!
postProfilingPercentage

	| fullDuration duration |
	fullDuration := self callgraph children 
		inject: 0 into: [:sum :each | sum := sum + (each valueOfProperty: #durationPercent) asNanoSeconds].
					
	self callgraph do: [:node | 
		(node includesProperty: #durationPercent) 
			ifTrue: [duration := (node valueOfProperty: #durationPercent) asNanoSeconds.
				node setProperty: #durationPercent toValue: ((duration / fullDuration) * 100.0) rounded]].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/15/2011 17:42:16.393'!
profile: aMode
	"Add profiling information to a callgraph. #duration, #durationPercent, #counts"
	
	(#(duration durationPercent counts) includes: aMode)
		ifFalse: [Error signal: 'Unsupported profiling mode.'].
	
	self tracingMode: aMode.
	self trace.! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/15/2011 16:48:17.002'!
profilingPostProcessing

	self tracingMode == #duration
		ifTrue: [self postProfilingMilliSeconds].
	self tracingMode == #durationPercent
		ifTrue: [self postProfilingPercentage].
	self tracingMode == #counts
		ifTrue: [self postProfilingCounts].! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:05:57.498'!
receiverClass: dict

	(dict at: #node)
		setProperty: #receiverClass
		toValue: (dict at: #receiver) class.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:02.244'!
receiverInstVarClassesAfter: dict

	(dict at: #node)
		setProperty: #receiverInstVarClassesAfter
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			((dict at: #receiver) instVarAt: idx) class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:06.091'!
receiverInstVarClassesBefore: dict

	(dict at: #node)
		setProperty: #receiverInstVarClassesBefore
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			((dict at: #receiver) instVarAt: idx) class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:14.845'!
receiverInstVarIdsAfter: dict

	(dict at: #node)
		setProperty: #receiverInstVarIdsAfter
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			self objectIdFor: ((dict at: #receiver) instVarAt: idx)]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:18.232'!
receiverInstVarIdsBefore: dict

	(dict at: #node)
		setProperty: #receiverInstVarIdsBefore
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			self objectIdFor: ((dict at: #receiver) instVarAt: idx)]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:06:22.754'!
receiverObjectAfter: dict

	(dict at: #node)
		setProperty: #receiverObjectAfter
		toValue: (dict at: #receiver) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:06:29.264'!
receiverObjectBefore: dict

	(dict at: #node)
		setProperty: #receiverObjectBefore
		toValue: (dict at: #receiver) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'tracing' stamp: 'mt 7/15/2011 17:57:38.024'!
reset
	"Reset the current position in the call tree and all local caches."

	self
		currentId: self callgraph rootId;
		currentNode: self callgraph;
		classDictionary: nil.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:08:02.855'!
returnClass: dict

	(dict at: #node)
		setProperty: #returnClass
		toValue: (dict at: #result) class.! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 12:57:39.085'!
returnFromNode: id
	
	self currentNode: (self currentNode id = id
		"Normal return."
		ifTrue: [self currentNode parent]
		"Wild jump through the stack!! =D"
		ifFalse: [(self callgraph findNodeInSubGraph: id startNode: self callgraph) parent]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 17:04:16.882'!
returnId: dict

	(dict at: #node)
		setProperty: #returnId
		toValue: (self objectIdFor: (dict at: #result)).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:07:29.209'!
returnObject: dict

	(dict at: #node)
		setProperty: #returnObject
		toValue: (dict at: #result) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 17:50:30.872'!
selectedClasses

	^ (self callgraph selectedCategories gather: [:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])! !

!SdCallgraphTracer methodsFor: 'tracing' stamp: 'mt 7/15/2011 17:51:19.78'!
trace

	self callgraph selectedCategories ifEmpty: [
		self autoSelectCategories].

	^ self trace: self createWrappers! !

!SdCallgraphTracer methodsFor: 'tracing' stamp: 'mt 7/15/2011 16:16:33.435'!
trace: someWrappers

	self reset.
	
	self installWrappers: someWrappers.

	"Set flag to optimize callgraph filling."
	isFirstRun := self callgraph isEmpty.

	[[
		| result |
		result := self callgraph run.
		self profilingPostProcessing.
		^ result
			] ensure: [self reset; uninstallWrappers: someWrappers]]
	
		on: SdNonDeterministicBehaviorDetected
		do: [:ex | self callgraph isNonDeterministic: true].
		
	^ nil! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/15/2011 17:54:10.38'!
traceEvent: aTraceItEvent
	"Create a new callgraph and re-use the selected categories."
	
	| selectedCategories |
	selectedCategories := self callgraph selectedCategories.
	
	self callgraph: (SdCallgraph new
		selectedCategories: selectedCategories;
		traceEvent: aTraceItEvent).
		
	^ self trace! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/14/2011 16:11:36.888'!
traceSourceCode: aSourceCodeString
	
	^ self
		traceSourceCode: aSourceCodeString
		receiver: nil! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/14/2011 16:14:23.229'!
traceSourceCode: aSourceCodeString receiver: anObject
	"Discards the current call graph and traces the given code."
	
	^ self traceEvent: (UiTraceItEvent
		expression: aSourceCodeString
		receiver: anObject)! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/14/2011 16:15:18.066'!
traceTest: aTestCaseClass method: aMethodSelector

	^ self traceEvent: (UiTraceItEvent testClass: aTestCaseClass selector: aMethodSelector)! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 16:48:51.715'!
tracingMode
	"#normal, #duration, #durationPercent, #counts, #property"

	^ tracingMode ifNil: [tracingMode := #normal]! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 16:43:38.796'!
tracingMode: anObject
	tracingMode := anObject! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 09:58:01.239'!
uninstallWrappers: someWrappers
	
	someWrappers do: [:each | each uninstall].! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 16:50:37.681'!
wrapperClass

	"Profile method calls, e.g., measure duration in milliseconds."
	(#(duration durationPercent counts) includes: self tracingMode)
		ifTrue: [^ SdProfilingWrapper].
		
	"Fetch additional properties for all nodes."
	self tracingMode == #property
		ifTrue: [^ SdGlobalPropertyWrapper].

	"Just basic callgraph."
	^ SdCallWrapper! !

Object subclass: #SdTestPerson
	instanceVariableNames: 'firstname lastname sibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph-Testbed'!

SdTestPerson subclass: #SdTestCustomer
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph-Testbed'!

!SdTestCustomer methodsFor: 'accessing' stamp: 'TM 5/17/2011 10:13:16.833'!
address

	^ address! !

!SdTestCustomer methodsFor: 'accessing' stamp: 'TM 5/17/2011 10:11:41.832'!
address: aString

	address := aString! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 4/26/2011 15:54:25.021'!
firstname
	"Answer the value of firstname"

	^ firstname! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 6/21/2011 16:06:36.25'!
firstname: anObject
	"Set the value of firstname"

	firstname := anObject! !

!SdTestPerson methodsFor: 'initialization' stamp: 'tfel 5/10/2011 17:25:17.408'!
initialize

	super initialize.
	firstname := 'Fritz'.
	lastname := 'Foo'.! !

!SdTestPerson methodsFor: 'signals' stamp: 'mt 7/16/2011 12:38:21.695'!
lastNameChanged: newLastName

	self emit.! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 4/26/2011 15:54:25.04'!
lastname
	"Answer the value of lastname"

	^ lastname! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:38:57.927'!
lastname: aString

	aString = lastname ifTrue: [^ self].
	lastname := aString.
	self lastNameChanged: lastname.! !

!SdTestPerson methodsFor: 'printing' stamp: 'mt 7/16/2011 12:35:26.186'!
nameAsScienceFictionHero
	"Convert the firstname into a super cool SF hero name."

	^ self firstname, 'ainous'! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:33:57.305'!
sibling

	^ sibling! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:33:49.872'!
sibling: aPerson

	sibling := aPerson.! !

!Debugger methodsFor: '*Sight-Cst-Debugger' stamp: 'bs 1/4/2011 20:13:57.378'!
debug: label executeBefore: aBlock
	"Open a full DebuggerView."
	Smalltalk isMorphic ifTrue: [
		self openFullNoSuspendLabel: label.
		"SStepper new executeInNextStep: ["aBlock value: self.
		errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: interruptedProcess].
! !

TestRunner subclass: #SCoverageTestRunner
	instanceVariableNames: 'isInTddAutoRunMode runsTestsInBackground modifiedMethods window runningTestMethod isActive'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'Sight-Cst-Coverage'!

SCoverageTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

SCoverageTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!SCoverageTestRunner class methodsFor: 'initialization' stamp: 'mt 2/23/2011 09:52:22.478'!
initialize

	self
		registerInWorldMenu;
		registerInToolsFlap.! !

!SCoverageTestRunner class methodsFor: 'tracing' stamp: 'mt 2/23/2011 09:52:01.044'!
mayMethodBeInstrumented: aSelector

	^ (#(isTracingActivated runningTestMethod) includes: aSelector) not! !

!SCoverageTestRunner class methodsFor: 'initialization' stamp: 'bs 7/20/2010 22:54:27.815'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( #SCoverageTestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!SCoverageTestRunner class methodsFor: 'initialization' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!SCoverageTestRunner class methodsFor: 'synchronizing' stamp: 'bs 8/19/2010 21:27:18.173'!
resetSourceCodeAccessMonitor
	" self resetSourceCodeAccessMonitor "
	^ RunInBackgroundMonitor := nil! !

!SCoverageTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/14/2009 10:50'!
sourceCodeAccessMonitor
	^ RunInBackgroundMonitor ifNil: [ RunInBackgroundMonitor := Monitor new ]! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:37.446'!
activateTracing
	isActive := true! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:02'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		layout: #vertical;
		children: {
			self buildButtonsWith: aBuilder.
			self buildTddControlButtonsWith: aBuilder
			};
		yourself.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:18'!
buildTddControlButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self tddFlags collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:16'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.84 );
				yourself);				
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.84 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.84);
				yourself);
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.84 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	^ aBuilder build: window.! !

!SCoverageTestRunner methodsFor: 'initialize-release' stamp: 'mt 2/14/2011 14:03:13.81'!
cleanUp

	self
		disableRunningTestsInBackground;
		isInTddAutoRunMode: false;
		reset.! !

!SCoverageTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:15'!
close
	window := nil! !

!SCoverageTestRunner methodsFor: 'system event handling' stamp: 'mt 2/14/2011 14:08:22.692'!
coverageEventHandler

	^ SCoverageEventHandler new
		coverageTestRunner: self! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 3/2/2011 21:02:37.701'!
createExtensionBlock
	^ [ :aMethod | 
		aMethod isTestMethod
			ifTrue: [ STestMethodExtension new ]
			ifFalse: [
				SNonTestMethodExtension new
					coverageTestRunner: self;
					yourself ]  ]! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:46.415'!
deactivateTracing
	isActive := false! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 7/20/2010 18:08:54.481'!
debugTest: aTestCase
	self withCurrentTest: aTestCase selectedMethod
		 do: [aTestCase debug]! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
defectTestMethods
	^ self result defectTestMethods! !

!SCoverageTestRunner methodsFor: 'accessing - background processing' stamp: 'mt 2/14/2011 14:05:20.23'!
disableRunningTestsInBackground
	
	runsTestsInBackground := false.! !

!SCoverageTestRunner methodsFor: 'accessing - background processing' stamp: 'mt 2/14/2011 14:05:26.137'!
enableRunningTestsInBackground
	
	runsTestsInBackground := true.! !

!SCoverageTestRunner methodsFor: 'system event handling' stamp: 'mt 2/14/2011 14:07:35.874'!
handleSystemEvent: anEvent

	self shouldNotImplement.! !

!SCoverageTestRunner methodsFor: 'accessing - auto run mode' stamp: 'mt 2/14/2011 13:56:09.317'!
isInTddAutoRunMode

	^ isInTddAutoRunMode ifNil: [isInTddAutoRunMode := false]! !

!SCoverageTestRunner methodsFor: 'accessing - auto run mode' stamp: 'mt 2/14/2011 14:01:07.471'!
isInTddAutoRunMode: aBoolean

	isInTddAutoRunMode = aBoolean ifTrue: [^ self].

	isInTddAutoRunMode := aBoolean.
	
	self
		changed: #tddAutoRunMode;
		changed: #tddAutoRunModeLabel.! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 8/10/2010 15:21:13.106'!
isTracingActivated
	^ isActive ifNil: [isActive := false]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!SCoverageTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:14'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'mt 2/14/2011 14:09:49.439'!
postprocess: aSightEvent

	aSightEvent removedMethods
		select: [:ea | ea isTestMethod]
		thenDo: [:ea | ea resetCoveredMethodsStatistics].! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'bs 3/3/2011 13:10:42.677'!
preprocess: aSightEvent
	aSightEvent addTestsToRun: (
		aSightEvent addedMethods select: [:ea | ea isTestMethod]).

	aSightEvent affectedMethods ifNotEmpty: [
		aSightEvent 
			addTestsToRun: (aSightEvent affectedMethods 
				flatCollect: [:ea | ea coveringTestMethods]);
			addTestsToRun: self defectTestMethods ].
	
	aSightEvent testsToRun
		do: [:ea | ea resetCoveredMethodsStatistics].
	
	aSightEvent removedMethods
		select: [:ea | ea isTestMethod]
		thenDo: [:ea | self result removeIfPresent: ea].

	"selector := self newMethod selector.
	methodClass := self newMethod methodClass.
	
	withTracingWrapper := CSWithTracingWrapper 
			on: selector inClass: methodClass inContext: aTestRunner codeSight.
	withTracingWrapper install. "! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'mt 2/14/2011 14:09:13.861'!
process: aSightEvent

	self runAndTraceTestMethods: aSightEvent testsToRun.
	aSightEvent testResult: self result.! !

!SCoverageTestRunner methodsFor: 'actions' stamp: 'bs 8/10/2010 17:24:43.525'!
reset
	self result: STestResult new; updateResults.! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:18:47.78'!
resetRunningTestMethod
	runningTestMethod := nil! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/10/2010 18:23:38.226'!
runAndTraceTestMethods: testMethods
	| aSuite |
	testMethods ifNotEmpty: [
		self reset.
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self activateTracing.
		self runSuite: aSuite.
		self deactivateTracing. ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/19/2010 21:27:32.892'!
runSuite: aSuite 
	| runSuiteSynchronized |
	runSuiteSynchronized := [	
		SCoverageTestRunner sourceCodeAccessMonitor critical: [
			self changed: #startTestRun.
			super runSuite: aSuite.
			self updateResultsInHistory.
			self changed: #endTestRun]].

	(self runsTestsInBackground and: [
			ProcessBrowser isUIProcess: Processor activeProcess])
		ifTrue: [ runSuiteSynchronized forkAt: Processor userBackgroundPriority ]
		ifFalse: [ runSuiteSynchronized value ]! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 8/10/2010 20:51:54.68'!
runTest: aTestCase
	self withCurrentTest: aTestCase selectedMethod
		 do: [super runTest: aTestCase.
			 self changed: #newTestResult with: result].
	
	! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:10:15.655'!
runningTestMethod
	^ runningTestMethod! !

!SCoverageTestRunner methodsFor: 'tracing' stamp: 'bs 7/20/2010 18:18:35.664'!
runningTestMethod: aCompiledMethod
	runningTestMethod := aCompiledMethod! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:11'!
runningTestsInBackgroundLabel
	^ self runsTestsInBackground
		ifTrue: [ 'DisableRunningTestsInBackground' ]
		ifFalse: [ 'EnableRunningTestsInBackground' ]! !

!SCoverageTestRunner methodsFor: 'accessing - background processing' stamp: 'mt 2/14/2011 14:05:33.158'!
runsTestsInBackground

	^ runsTestsInBackground ifNil: [runsTestsInBackground := false]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:06'!
tddAutoRunModeLabel
	^ self isInTddAutoRunMode 
		ifTrue: [ 'Stop Tdd Auto Run Mode' ]
		ifFalse: [ 'Start Tdd Auto Run Mode' ]! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:03'!
tddFlags
	^ #(( #tddAutoRunModeLabel #toggleTddAutoRunMode )
		( #runningTestsInBackgroundLabel #toggleRunningTestsInBackground )).! !

!SCoverageTestRunner methodsFor: 'event processing' stamp: 'mt 2/14/2011 14:09:02.483'!
testMethodRemoved: aTestMethod

	self shouldNotImplement.! !

!SCoverageTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:21'!
toggleRunningTestsInBackground
	self runsTestsInBackground
		ifTrue: [ self disableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]
		ifFalse: [ self enableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]! !

!SCoverageTestRunner methodsFor: 'accessing - auto run mode' stamp: 'mt 2/14/2011 14:00:58.401'!
toggleTddAutoRunMode

	self isInTddAutoRunMode: self isInTddAutoRunMode not.! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 3/3/2010 09:01:30.036'!
updateResultsInHistory
	(TestResult includesSelector: #updateResultsInHistory) 
		ifTrue: [ self result updateResultsInHistory ].! !

!SCoverageTestRunner methodsFor: 'running' stamp: 'bs 7/20/2010 22:58:41.06'!
withCurrentTest: aTestMethod do: aBlock
	self runningTestMethod: aTestMethod.
	aTestMethod resetCoveredMethodsStatistics.
	aBlock value.
	self resetRunningTestMethod.
	! !

MwMethodWrapper subclass: #SDebuggingWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Debugger'!

!SDebuggingWrapper class methodsFor: 'instance creation' stamp: 'bs 1/4/2011 18:26:01.902'!
onMethod: aCompiledMethod
	^ self 
		on: aCompiledMethod selector 
		inClass: aCompiledMethod methodClass.! !

!SDebuggingWrapper methodsFor: 'as yet unclassified' stamp: 'bs 1/4/2011 18:12:37.151'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| previousPc |
	self uninstall.
	(Debugger context: thisContext)
		debug: 'Debugging an Example' executeBefore: [:debugger | 
			debugger down; down.
			previousPc := debugger selectedContext previousPc.
			debugger restart.
			[debugger selectedContext pc < previousPc] 
				whileTrue: [debugger doStep].
			debugger send ].
	Processor activeProcess suspend.! !

MwMethodWrapper subclass: #SRefactoringVariationWrapper
	instanceVariableNames: 'variationMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst'!

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 22:59'!
initialize
	"self initialize"
	super initialize! !

!SRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 22:14:46.852'!
on: aSelectorSymbol inClass: aClass withCode: sourceCodeString
	| wrapper variationAst |
	wrapper := super on: aSelectorSymbol inClass: aClass.
	variationAst := Compiler new 
						compile: sourceCodeString in: aClass
						notifying: nil
						ifFail: [].
	wrapper variationMethod: (variationAst generateUsing: aClass).
	^ wrapper! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 23:00'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	^ self variationMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:28.155'!
variationMethod
	^ variationMethod! !

!SRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 4/23/2010 10:02:18.259'!
variationMethod: aCompiledMethod
	variationMethod := aCompiledMethod! !

MwMethodWrapper subclass: #SdCallWrapper
	instanceVariableNames: 'ids tracer callsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdCallWrapper class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 14:25'!
on: aSymbol inClass: aClass withTracer: aTracer

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:34:47.59'!
afterMethod: anObject with: arguments result: returnValue

	self tracer returnFromNode: self ids removeLast.! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/14/2011 12:14:58.75'!
beforeMethod: anObject with: arguments

	self ids add: (self tracer 
				nextCallNodeOn: self wrappedClass 
				with: self clientSelector
				receiverObject: anObject
				arguments: arguments
				callsBefore: self callsBefore).! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore
	"Answer the value of callsBefore"

	^ callsBefore! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore: anObject
	"Set the value of callsBefore"

	callsBefore := anObject! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids
	"Answer the value of ids"

	^ ids! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids: anObject
	"Set the value of ids"

	ids := anObject! !

!SdCallWrapper methodsFor: 'initialization' stamp: 'mp 6/15/2010 16:09'!
initialize

	self ids: OrderedCollection new.
	self callsBefore: 0.! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:34:35.564'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| returnValue |

	self beforeMethod: anObject with: anArrayOfObjects.

	self callsBefore: self callsBefore + 1.
	returnValue := super valueWithReceiver: anObject arguments: anArrayOfObjects.

	self afterMethod: anObject with: anArrayOfObjects result: returnValue.

	^ returnValue! !

SdCallWrapper subclass: #SdGlobalPropertyWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdGlobalPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 17:14:40.683'!
afterMethod: anObject with: arguments result: returnValue

	"Collect the properties."
	self tracer
		collectGlobalPropertiesAfterReceiver: anObject
		arguments: arguments
		returnValue: returnValue.
		
	super afterMethod: anObject with: arguments result: returnValue.! !

!SdGlobalPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 17:06:25.27'!
beforeMethod: anObject with: arguments

	"Let the tracer select the correct node."
	super beforeMethod: anObject with: arguments.
	
	"Collect the properties."
	self tracer
		collectGlobalPropertiesBeforeReceiver: anObject
		arguments: arguments.! !

SdCallWrapper subclass: #SdProfilingWrapper
	instanceVariableNames: 'stopwatchs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdProfilingWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:35:00.229'!
afterMethod: anObject with: arguments result: returnValue

	self tracer
		addProfileInformation: ((self stopwatchs removeLast)
			suspend;
			duration)
		node: self ids last.

	super afterMethod: anObject with: arguments result: returnValue.! !

!SdProfilingWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:28:53.576'!
beforeMethod: anObject with: arguments

	super beforeMethod: anObject with: arguments.
	(self stopwatchs add: Stopwatch new) activate.! !

!SdProfilingWrapper methodsFor: 'initialization' stamp: 'mt 7/14/2011 12:10:49.795'!
initialize

	super initialize.
	stopwatchs := OrderedCollection new.! !

!SdProfilingWrapper methodsFor: 'accessing' stamp: 'mp 1/26/2010 09:28'!
stopwatchs
	"Answer the value of stopwatchs"

	^ stopwatchs! !

MwMethodWrapper subclass: #SdNonDeterministicBehaviorNotifier
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdNonDeterministicBehaviorNotifier commentStamp: 'mt 7/15/2011 13:23:55.672' prior: 0!
Install this wrapper on methods that cause random behavior.!

!SdNonDeterministicBehaviorNotifier class methodsFor: 'instance creation' stamp: 'mt 7/15/2011 13:29:41.506'!
on: aSymbol inClass: aClass withTracer: aTracer

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'accessing' stamp: 'mt 7/15/2011 13:28:35.156'!
tracer

	^ tracer! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'accessing' stamp: 'mt 7/15/2011 13:28:40.25'!
tracer: aTracer

	tracer := aTracer.! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'evaluating' stamp: 'mt 7/15/2011 13:29:22.618'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	self tracer callgraph isNonDeterministic: true.
	^ super valueWithReceiver: anObject arguments: anArrayOfObjects! !

MwMethodWrapper subclass: #SdSpecificWrapper
	instanceVariableNames: 'numberOfCallsBefore tracer node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

SdSpecificWrapper subclass: #SdByteCodeCoverageWrapper
	instanceVariableNames: 'coveredByteCodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:21:28.79'!
coveredByteCodes
	"Answer the value of coveredByteCodes"

	^ coveredByteCodes ifNil: [coveredByteCodes := OrderedCollection new]! !

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:19:07.504'!
coveredByteCodes: anObject
	"Set the value of coveredByteCodes"

	coveredByteCodes := anObject! !

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 10:03:04.545'!
data

	^ self coveredByteCodes! !

!SdByteCodeCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 11/8/2010 15:54:55.976'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| result |
	self isSpecificCall 
		ifTrue: [self decrementCallCount.
				result := thisContext
							runSimulatedMethodOnly: [self clientMethod 
															valueWithReceiver: anObject 
															arguments: anArrayOfObjects]
							contextAtEachStep: [ :ctx | 
								self compiledMethod == ctx method
									ifTrue: [	self coveredByteCodes add: ctx pc]]]
		ifFalse: [self decrementCallCount.
				result := self clientMethod 
								valueWithReceiver: anObject 
								arguments: anArrayOfObjects].
	^ result! !

SdSpecificWrapper subclass: #SdDebugWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdDebugWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 10:15:20.289'!
beforeMethod

	self numberOfCallsBefore = 1
		ifTrue: [BreakpointManager
			installInClass: self wrappedClass
			selector: self clientSelector].
	self decrementCallCount.! !

!SdDebugWrapper methodsFor: 'installation' stamp: 'mt 7/15/2011 10:14:56.169'!
uninstall

	BreakpointManager unInstall: self wrappedClass >> self clientSelector.
	super uninstall.! !

SdSpecificWrapper subclass: #SdSpecificPropertyWrapper
	instanceVariableNames: 'found'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Cst-Callgraph'!

!SdSpecificPropertyWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found
	"Answer the value of found"

	^ found ifNil: [found := false]! !

!SdSpecificPropertyWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found: anObject
	"Set the value of found"

	found := anObject! !

!SdSpecificPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 15:14:35.001'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	self isSpecificCall ifTrue: [
		self found: true.
		self tracer
			collectPropertiesBeforeNode: self node
			receiver: anObject
			arguments: anArrayOfObjects].
	
	self decrementCallCount.
	
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	
	self found ifTrue: [
		self incrementCallCount.

		self tracer
			collectPropertiesAfterNode: self node
			receiver: anObject
			arguments: anArrayOfObjects 
			returnValue: result.

		self isSpecificCall ifTrue: [
			self
				found: false;
				decrementCallCount]].
		
	^ result
! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 10:03:14.668'!
data
	"Return the collected data of this specific wrapper."

	^ nil! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:39'!
decrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore - 1.! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 19:07'!
incrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore + 1.! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:40'!
isSpecificCall
	
	^ self numberOfCallsBefore = 0! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:13:09.364'!
node

	^ node! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:13:14.683'!
node: aNode

	node := aNode.! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore
	"Answer the value of numberOfCallsBefore"

	^ numberOfCallsBefore! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore: anObject
	"Set the value of numberOfCallsBefore"

	numberOfCallsBefore := anObject! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 14:25:08.484'!
tracer

	^ tracer! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 14:25:13.846'!
tracer: aTracer

	tracer := aTracer.! !
SReplicator initialize!
SFailedExpressionStyler initialize!
SCoverageTestRunner initialize!
SRefactoringVariationWrapper initialize!
